const { request, response } = require("express");
const connection = require("../connection/dbconfig");

const languageMessages = require("./languageMessages");
var deeplink = require('node-deeplink');

// get all content start

// get content start

const getContent = (request, response) => {
    try {

        const {language_id} = request.query;
        if(!language_id){
            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'language_id' });        }
       
        var query = "SELECT content_id, content_type,content FROM content_master WHERE delete_flag = ?";
        connection.query(query, [0], (err, rows) => {
            if (err) {
                console.error('Error executing MySQL query:', err);
                return response.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
            }
            let content_arr = [];

            var webservice_url = 'https://meribhiapp.com/2024/musaapp/server/webservice/';

            if (rows.length > 0) {
                content_arr = rows.map(row => ({
                    content_id: row.content_id,
                    content_type: row.content_type,
                    content: row.content,
                    content_url: `${webservice_url}get_all_content_url?content_type=${row.content_type}&language_id=${language_id}`
                }));
            } else {
                content_arr = 'NA';
            }
            const record = { success: true, msg: languageMessages.msgDataFound, content_arr: content_arr };
            response.json(record);
        })
    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError });
    }
};


const getAllContentUrl = (request, response) => {
    try {
        const { content_type, language_id } = request.query;

        const query1 = "SELECT content_id, content_type, content FROM content_master WHERE delete_flag = 0 AND content_type = ?";
        const val1 = [content_type];
        
        connection.query(query1, val1, (valError, valResult) => {
            if (valError) {
                return response.status(500).json({ success: false, msg: languageMessages.internalServerError });
            }

            if (valResult.length === 0) {
                return response.status(404).json({ success: false, msg: languageMessages.msgDataNotFound });
            }
            let content_en = 'NA';
            if(language_id==0){
                content_en = valResult[0].content
            }
           
             
            let new12 = '<html><head><meta charset="utf-8"><meta http-equiv="Content-Security-Policy" content="default-src * data: gap: content:"><meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, minimum-scale=1, user-scalable=no, minimal-ui"><title>Data</title></head><body style="word-break: break-all;">' + content_en + '</body></html>';


            return response.send(new12);
        });
    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError });
    }
};


// get content end 

// get all content end

const downloadApp = async (request, response) => {
    response.send(
        `
    <!DOCTYPE html>
    <html lang="en-US">
    <head>
        <title>Musa</title>
        <meta http-equiv="content-type" content="text/html; charset=utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
    </head>
    <body>
        <section>
            <div class="btn-holder">
                <a class="btn" href="https://www.apple.com/in/app-store/" style="padding-left: 0;">
                    <img alt="" src="https://meribhiapp.com/2024/musaapp/server/webservice/controller/downloadImg/appstore.png">
                </a>
                <a class="btn" href="https://play.google.com/store/apps">
                    <img alt="" src="https://meribhiapp.com/2024/musaapp/server/webservice/controller/downloadImg/googleplay.png">
                </a>
            </div>
        </section>
    </body>
    </html>
  `
    );
};


const deepLink = async (request, response) => {
    const { link } = request.query;
    const get_link = link;
  
    response.send(`
      <!DOCTYPE html>
      <html>
        <head>
          <title>Wait...</title>
          <script src='https://code.jquery.com/jquery-1.11.2.min.js'></script>
          <script>
            (function() {
              var app = {
                launchApp: function() {
                  var get_link = '${get_link}';
                  window.location.replace(get_link);
                  this.timer = setTimeout(this.openWebApp, 3000);
                },
                openWebApp: function() {
                  window.location.replace("https://meribhiapp.com/2024/musaapp/server/webservice/downloadApp");
                }
              };
              app.launchApp();
            })();
          </script>
          <style type="text/css">
            .twitter-detect {
              display: none;
            }
          </style>
        </head>
        <body>
          <p>Website content.</p>
        </body>
      </html>
    `);
  };
  

module.exports = {getContent,getAllContentUrl,downloadApp,deepLink}