const connection = require("../connection/dbconfig");
const languageMessages = require("./languageMessages");
const util = require('util');
const {getSingleAllCategoryData, getSingleSubCategoryData,getFollowStatus1,displayStatus} = require("./musaController");
require("dotenv").config()
const moment = require('moment');
const { resolve } = require("path");
const { rejects } = require("assert");
function fetchUserData(userId, callback) {
    const query = "SELECT * FROM user_master WHERE user_id = ? ";
  
    connection.query(query, [userId], async(error, results) => {
        if (error) {
            callback(error, null);
            return;
        }
        if (results.length > 0) {
            const userData = results[0]; 
            let dob_new =  formatDate(userData.dob);
            const formatted_dob = moment(dob_new).format('MM/DD/YYYY');
            const age = moment().diff(dob_new, 'years');
            const gb = await getGB(userData.user_id);
            const used_gb = await getUsedGb(userData.user_id);
            const total_gb = await totalGb(userData.user_id);

            let oneGb = 1073741824;  // one gb is in byte
            let total_kb = total_gb*oneGb;
            let total_remaining_gb = total_kb - used_gb;

            const userDataArray = {
   
                total_kb: total_kb,
                total_gb: total_gb,
                total_used_gb: used_gb,
                total_remaining_gb: total_remaining_gb > 0 ? total_remaining_gb : 0,
                user_id: userData.user_id,
                user_type: userData.user_type,
                user_type_lable : "0=admin,1= user",
                login_type : userData.login_type,
                login_type_lable : "0=app, 1=google, 2=apple",
                email: userData.email,
                f_name: userData.f_name,
                l_name: userData.l_name,
                name: userData.name,
                dob: dob_new,
                formatted_dob: formatted_dob,
                age: age,
                phone_code: userData.phone_code,
                mobile: userData.mobile,
                otp: userData.otp,
                otp_verify: userData.otp_verify,
                image: userData.image,
                bio : userData.bio,
                gb : gb,
                remaining_gb : gb,
                used_gb : used_gb,
                bio_type : userData.bio_type,
                zipcode : userData.zipcode,
                bio_type_lable : "0 for text, 1 for audio	",
                gender_lable: '1=men,2=women,3=other',
                gender: userData.gender,
                address: userData.address,
                latitude: userData.latitude,
                longitude: userData.longitude,
                active_flag: userData.active_flag,
                approve_flag: userData.approve_flag,
                profile_complete: userData.profile_complete,
                language_id: userData.language_id,
                facebook_id: userData.facebook_id,
                google_id: userData.google_id,
                apple_id: userData.apple_id,
                notification_status: userData.notification_status,
                delete_reason: userData.delete_reason,
                createtime: userData.createtime,
                updatetime: userData.updatetime,

            };
            callback(null, userDataArray);
        } else {
            callback(null, null);
        }
    });
  }


// fetch address data start
function featchAddressData(userId,callback){
    const query1 = "SELECT address_id, user_id, flat_no, address, landmark, address_type, latitude, longitude FROM address_master WHERE user_id = ? AND delete_flag = 0";
    connection.query(query1,[userId],(error,result)=>{
        if (error) {
            callback(error, null);
            return;
        }
        var address_arr = [];
        if(result.length > 0){
            result.forEach(row => {
                address_arr.push({
                    address_id: row.address_id,
                    user_id: row.user_id,
                    flat_no : row.flat_no,
                    address: row.address,
                    landmark: row.landmark,
                    address_type : row.address_type,
                    landmark: row.latitude,
                    address_type : row.longitude,
                });
            });
            if (address_arr.length === 0) {
                address_arr = 'NA';
            }
            callback(null, address_arr);
        }else{
            callback(null, null);
        }
    })
}
// fetch address data end

  function DeviceTokenStore_1_Signal(user_id, device_type, player_id, callback) {

    const inserttime = new Date().toISOString().slice(0, 19).replace('T', ' ');

    // Check if player_id exists
    connection.query('SELECT player_id FROM user_notification WHERE player_id = ?', [player_id], function (error, results, fields) {
        if (error) throw error;

        if (results.length > 0) {
            // Delete all records of this player_id
            connection.query('DELETE FROM user_notification WHERE player_id = ? OR user_id = ?', [player_id, user_id], function (error, results, fields) {
                if (error) throw error;

                if (results.affectedRows <= 0) {
                    // 2nd attempt to delete
                    connection.query('DELETE FROM user_notification WHERE player_id = ? OR user_id = ?', [player_id, user_id], function (error, results, fields) {
                        if (error) throw error;

                        if (results.affectedRows <= 0) {
                            callback("no");
                        } else {
                            // Insert new record
                            connection.query('INSERT INTO user_notification (user_id, device_type, player_id, inserttime) VALUES (?, ?, ?, ?)', [user_id, device_type, player_id, inserttime], function (error, results, fields) {
                                if (error) throw error;

                                if (results.affectedRows > 0) {
                                    callback("yes");
                                } else {
                                    callback("no");
                                }
                            });
                        }
                    });
                } else {
                    // Insert new record
                    connection.query('INSERT INTO user_notification (user_id, device_type, player_id, inserttime) VALUES (?, ?, ?, ?)', [user_id, device_type, player_id, inserttime], function (error, results, fields) {
                        if (error) throw error;

                        if (results.affectedRows > 0) {
                            callback("yes");
                        } else {
                            callback("no");
                        }
                    });
                }
            });
        } else {
            // Check if user_id exists
            connection.query('SELECT user_id FROM user_notification WHERE user_id = ?', [user_id], function (error, results, fields) {
                if (error) throw error;

                if (results.length > 0) {
                    // Delete all records of this user_id
                    connection.query('DELETE FROM user_notification WHERE user_id = ?', [user_id], function (error, results, fields) {
                        if (error) throw error;

                        if (results.affectedRows <= 0) {
                            // 2nd attempt to delete
                            connection.query('DELETE FROM user_notification WHERE user_id = ?', [user_id], function (error, results, fields) {
                                if (error) throw error;

                                if (results.affectedRows <= 0) {
                                    callback("no");
                                } else {
                                    // Insert new record
                                    connection.query('INSERT INTO user_notification (user_id, device_type, player_id, inserttime) VALUES (?, ?, ?, ?)', [user_id, device_type, player_id, inserttime], function (error, results, fields) {
                                        if (error) throw error;

                                        if (results.affectedRows > 0) {
                                            callback("yes");
                                        } else {
                                            callback("no");
                                        }
                                    });
                                }
                            });
                        } else {
                            // Insert new record
                            connection.query('INSERT INTO user_notification (user_id, device_type, player_id, inserttime) VALUES (?, ?, ?, ?)', [user_id, device_type, player_id, inserttime], function (error, results, fields) {
                                if (error) throw error;

                                if (results.affectedRows > 0) {
                                    callback("yes");
                                } else {
                                    callback("no");
                                }
                            });
                        }
                    });
                } else {
                    // Insert new record
                    connection.query('INSERT INTO user_notification (user_id, device_type, player_id, inserttime) VALUES (?, ?, ?, ?)', [user_id, device_type, player_id, inserttime], function (error, results, fields) {
                        if (error) throw error;

                        if (results.affectedRows > 0) {
                            callback("yes");
                        } else {
                            callback("no");
                        }
                    });
                }
            });
        }
    });
}


function formatDate(dateString) {
    const date = new Date(dateString);
    const year = date.getFullYear();
    const month = String(date.getMonth() + 1).padStart(2, '0');
    const day = String(date.getDate()).padStart(2, '0');
    return `${year}-${month}-${day}`;
}


async function getUserData(userId) {
    return new Promise((resolve, reject) => {
      const query1 = "SELECT  `user_id`, `login_type`, `login_type_first`, `user_type`, `email`, `password`, `username`, `f_name`, `l_name`, `name`, `dob`, `age`, `phone_code`, `mobile`, `otp`, `otp_verify`, `image`, `gender`, `address`, `latitude`, `longitude`, `zipcode`, `bio`, `bio_type`, `active_flag`, `approve_flag`, `profile_complete`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`, `notification_status`, `delete_flag`, `delete_reason`, `createtime`, `updatetime`, `mysqltime`, `signup_step`, `avatar_id`, `currect_location_permanent`, `about` FROM user_master WHERE user_id = ? and delete_flag=0";
  
      connection.query(query1, [userId], async (error, results) => {
        if (error) {
          reject(error);
          return;
        }
  
        if (results.length > 0) {
          const userData = results[0];  
          try {
            const userDataArray = {
              user_id: userData.user_id,
              login_type: userData.login_type,
              login_type_first: userData.login_type_first,
              user_type: userData.user_type,
              email: userData.email,
              username : userData.username,
              f_name: userData.f_name,
              l_name: userData.l_name,
              name: userData.name,
              dob: userData.dob,
              age: userData.age,
              phone_code: userData.phone_code,
              mobile: userData.mobile,
              otp: userData.otp,
              otp_verify: userData.otp_verify,
              image: userData.image,
              gender: userData.gender,
              address: userData.address,
              latitude: userData.latitude,
              longitude: userData.longitude,
              zipcode : userData.zipcode,
              active_flag: userData.active_flag,
              approve_flag: userData.approve_flag,
              profile_complete: userData.profile_complete,
              language_id: userData.language_id,
              facebook_id: userData.facebook_id,
              google_id: userData.google_id,
              apple_id: userData.apple_id,
              notification_status: userData.notification_status,
              delete_reason: userData.delete_reason,
              createtime: userData.createtime,
              updatetime: userData.updatetime,
              bio: userData.bio,
              bio_type : userData.bio_type,
              signup_step: userData.signup_step,
              about : userData.about,
            };
            resolve(userDataArray);
          } catch (err) {
            reject(err);
          }
        } else {
          resolve(null);
        }
      });
    });
  }
  
async function getGB(user_id) {
    var sqlstatus = "SELECT user_id,plan_id from user_plan_master where user_id = ? AND delete_flag = 0 AND status = 1";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0){
                    var sqlstatus = "SELECT gb from plan_master where plan_id = ? AND delete_flag = 0 ";
                    // return new Promise((resolve, reject) => {
                    connection.query(sqlstatus, [result[0].plan_id], (err, data) => {
                    if (err) {
                        reject(err);
                    } 
                    if(data.length > 0){
                        resolve(data[0].gb);
                    }
                    else{
                        resolve("NA");  
                    }
                });
             }else {
                resolve("NA");
             }
            }
        });
    });
}

async function getMusaImage(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`duration`  FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                let musa_image_arr = [];
           
                for (const row of result) 
                    if(row.image_audio_type === 1){
                        musa_image_arr.push({
                            musa_id : row.musa_id,
                            image_audio : row.image_audio,
                            duration : row.duration
                    });
                    }
                }
                if(musa_image_arr.length <= 0){
                    musa_image_arr = "NA";
                }

                resolve(musa_image_arr);
            });
        })
    }




    async function getMusavideo(musa_id, user_id) {
        const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`duration`  FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
        return new Promise((resolve, reject) => {
            connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
                if (err) {
                    reject(err);
                } else {
                    let musa_video_arr = [];
               
                    for (const row of result) 
                        if(row.image_audio_type === 3){
                            musa_video_arr.push({
                                musa_image_id: row.musa_image_id,
                                duration: row.duration,
                                thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/'+row.thumbnail_image,
                                image_audio:'https://d38i924xuvvpvh.cloudfront.net/images/'+row.image_audio,
                            });
                        }
                    }
                    if(musa_video_arr.length <= 0){
                        musa_video_arr = "NA";
                    }
    
                    resolve(musa_video_arr);
                });
            })
        }

 
            
        async function getMusavideoNew(musa_id, user_id) {
            const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`, `size_flag`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ? and image_audio_type = 3";
            return new Promise((resolve, reject) => {
                connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
                    if (err) {
                        reject(err);
                    } else {
                        let videos = [];
                        let images = [];
                        let largeImages = [];
                        // [3, 4, 5, 10, 11, 12, 13, 17, 18, 19, 24, 25, 26, 31, 32, 33, 38, 39, 40, 45, 46, 47, 52, 53, 54, 59, 60, 61, 66, 67, 68, 73, 74, 75, 80, 81, 82, 87, 88, 89, 94, 95, 96, 101, 102, 103, 108, 109, 110, 115, 116, 117, 122, 123, 124, 129, 130, 131, 136, 137, 138, 143, 144, 145, 150, 151, 152, 157, 158, 159, 164, 165, 166, 171, 172, 173, 178, 179, 180, 185, 186, 187, 192, 193, 194, 199, 200]
                        // let normalPlacementIndexes = [3,4,5,10,11,12,13,17,18,19,24,25,26,31,32,33,38,39,40,45,46,47,52,53,54,59,60,61,66,67,68,73,74,75,80,81,82,87,88,89,94,95,96,101,102,103,108,109,110,115,116,117,122,123,124,129,130,131,136,137,138,143,144,145,150,151,152,157,158,159,164,165,166,171,172,173,178,179,180,185,186,187,192,193,194,199,200,201,206,207,208,213,214,215,220,221,222,227,228,229,234,235,236,241,242,243,248,249,250,255,256,257,262,263,264,269,270,271,276,277,278,283,284,285,290,291,292];
//                         const increments = [1, 1, 5];
// let current_value = 17;
// let normalPlacementIndexes = [3, 4, 5, 10, 11, 12, 13, 17];

// while (current_value < 1000) {
// for (let increment of increments) {
//     current_value += increment;
//     if (current_value > 1000) {
//         break;
//     }
//     normalPlacementIndexes.push(current_value);
// }
// }

// console.log(normalPlacementIndexes);

//                         let videoPlacementIndexes = [1, 2, 8, 9, 15, 16, 22, 23, 29, 30, 36, 37, 43, 44, 50, 51, 57, 58, 64, 65, 71, 72, 78, 79, 85, 86, 92, 93, 99, 100, 106, 107, 113, 114, 120, 121, 127, 128, 134, 135, 141, 142, 148, 149, 155, 156, 162, 163, 169, 170, 176, 177, 183, 184, 190, 191, 197, 198, 204, 205, 211, 212, 218, 219, 225, 226, 232,233,239,240,246,247,253,254,260,261,267,268,274,275,281,282,288,289,295,296,302,303];
//                             let current_value1 = 0;
// let videoPlacementIndexes = [];

// while (current_value1 < 1000) { // Use 303 as the limit based on the given series
//     for (let i = 0; i < 1; i++) { // Increment by 1
//         current_value1 += 1;
//         videoPlacementIndexes.push(current_value1);
//     }
//     for (let i = 0; i < 1; i++) { // Increment by 1 again
//         current_value1 += 1;
//         videoPlacementIndexes.push(current_value1);
//     }
//     for (let i = 0; i < 1; i++) { // Increment by 6
//         current_value1 += 6;
//         videoPlacementIndexes.push(current_value1);
//     }
// for (let i = 0; i < 1; i++) { // Increment by 1
//     current_value1 += 1;
//     videoPlacementIndexes.push(current_value1);
// }
// for (let i = 0; i < 1; i++) { // Increment by 1 again
//     current_value1 += 1;
//     videoPlacementIndexes.push(current_value1);
// }
// for (let i = 0; i < 1; i++) { // Increment by 6
//     current_value1 += 6;
//     videoPlacementIndexes.push(current_value1);
// }
// }

// Adjust the limit and pattern to stop at the correct value
// videoPlacementIndexes = videoPlacementIndexes.filter(index => index <= 1000);

// console.log(videoPlacementIndexes);

                        // let largeImagePlacementIndexes = [0, 6, 7, 14, 20, 21, 27, 28, 34, 35, 41, 42, 48, 49, 55, 56, 62, 63, 69, 70, 76, 77, 83, 84, 90, 91, 97, 98, 104, 105, 111, 112, 118, 119, 125, 126, 132, 133, 139, 140, 146, 147, 153, 154, 160, 161, 167, 168, 174, 175, 181, 182, 188, 189, 195, 196, 202, 203, 209, 210, 216, 217, 223, 224,230,231,237,238,244,245,251,252,258,259,265,266,272,273,279,280,286,287,293,294,300,301];
//                         let largeImagePlacementIndexes = [0, 6, 7, 14];
// const increments1 = [6, 1];
// let current_value2 = 14;

// while (current_value2 < 1000) {
// for (let increments of increments1) {
//     current_value2 += increments;
//     if (current_value2 > 1000) {
//         break;
//     }
//     largeImagePlacementIndexes.push(current_value2);
// }
// }

// console.log(largeImagePlacementIndexes);
        
                        // Separate videos, images, and large images based on type and size_flag
                        for (const row of result) {
                            // if (row.image_audio_type === 3) { // Video
                                videos.push({
                                    musa_image_id: row.musa_image_id,
                                    duration: row.duration,
                                    size_flag: row.size_flag,
                                    size_flag_text: '0=normal,1=lengthy',
                                    image_audio_type: row.image_audio_type,
                                    image_audio_type_text: '1=image,3=video',
                                    image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                                    thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
                                });
                            // } else if (row.image_audio_type === 1) { // Image
                            //     if (row.size_flag === 1) {
                            //         largeImages.push({
                            //             musa_image_id: row.musa_image_id,
                            //             size_flag: row.size_flag,
                            //             size_flag_text: '0=normal,1=lengthy',
                            //             image_audio_type: row.image_audio_type,
                            //             image_audio_type_text: '1=image,3=video',
                            //             image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            //             thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
                            //         });
                            //     } else {
                                //     images.push({
                                //         musa_image_id: row.musa_image_id,
                                //         size_flag: row.size_flag,
                                //         size_flag_text: '0=normal,1=lengthy',
                                //         image_audio_type: row.image_audio_type,
                                //         image_audio_type_text: '1=image,3=video',
                                //         image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                                //         thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
                                //     });
                                // }
                            // }
                        }
        
                        // Initialize finalArr with 'NA' for all specified indexes
                        // let maxIndex = Math.max(...videoPlacementIndexes, ...largeImagePlacementIndexes, ...normalPlacementIndexes);
                        // let finalArr = new Array(maxIndex + 1).fill('NA');
        
                        // // Place videos at specific indexes
                        // videos.forEach((video, index) => {
                        //     if (index < videoPlacementIndexes.length) {
                        //         finalArr[videoPlacementIndexes[index]] = video;
                        //     }
                        // });
        
                        // // Place large images at specific indexes
                        // largeImages.forEach((image, index) => {
                        //     if (index < largeImagePlacementIndexes.length) {
                        //         finalArr[largeImagePlacementIndexes[index]] = image;
                        //     }
                        // });
        
                        // // Place other images in the remaining slots
                        // images.forEach((image, index) => {
                        //     if (index < normalPlacementIndexes.length) {
                        //         finalArr[normalPlacementIndexes[index]] = image;
                        //     }
                        // });
        
                        // Trim 'NA' from the end if no images or videos exist after the last defined index
                        // while (finalArr.length > 0 && finalArr[finalArr.length - 1] === 'NA') {
                        //     finalArr.pop();
                        // }
        
                        resolve(videos);
                    }
                });
            });
        }
        
            
          
          
          
//             async function getMusavideoImage(musa_id, user_id) {
//                 const sqlSelect = "SELECT mim.musa_image_id, mim.image_audio, mim.thumbnail_image,mim.musa_id, mim.user_id, mim.type, mim.image_audio_type, mim.size_flag FROM musa_image_master as mim , musa_master as mm WHERE mim.musa_id = ? AND mim.user_id = ? and mim.image_audio_type=1 and mm.delete_flag=0 and mim.musa_id=mm.musa_id";
//                 return new Promise((resolve, reject) => {
//                     connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
//                         if (err) {
//                             reject(err);
//                         } else {
//                             let videos = [];
//                             let images = [];
//                             let largeImages = [];
                          
//                             const increments = [1, 1, 5];
// let current_value = 17;
// let normalPlacementIndexes = [3, 4, 5, 10, 11, 12, 13, 17];

// while (current_value < 1000) {
//     for (let increment of increments) {
//         current_value += increment;
//         if (current_value > 1000) {
//             break;
//         }
//         normalPlacementIndexes.push(current_value);
//     }
// }

// console.log(normalPlacementIndexes);

//                             let videoPlacementIndexes = [1, 2, 8, 9, 15, 16, 22, 23, 29, 30, 36, 37, 43, 44, 50, 51, 57, 58, 64, 65, 71, 72, 78, 79, 85, 86, 92, 93, 99, 100, 106, 107, 113, 114, 120, 121, 127, 128, 134, 135, 141, 142, 148, 149, 155, 156, 162, 163, 169, 170, 176, 177, 183, 184, 190, 191, 197, 198, 204, 205, 211, 212, 218, 219, 225, 226, 232,233,239,240,246,247,253,254,260,261,267,268,274,275,281,282,288,289,295,296,302,303,309,310,316,317,323,324,330,331,337,343,344,350,351,357,358,364,365,371,372,378,379,385,386,392,393,399,400,406,407,413,414,420,421,427,428,434,435,441,442,448,449,455,456,462,463,469,470,476,477,483,484,490,491,497,498,504,505,511,512,518,519,525,526,532,533,539,540,546,547,553,554,560,561,567,568,574,575,581,582,588,589,595,596,602,603,609,610,616,617,623,624,630,631,637,638,644,645,651,652,658,659,665,666,672,673,679,680,686,687,693,694,700,701,707,708,714,715,721,722,728,729,735,736,742,743,749,750,756,757,763,764,770,771,777,778,784,785,791,792,798,799,805,806,812,813,819,820,826,827,833,834,840,841,847,848,856,857,863,864,870,871,877,878,884,885,891,892,898,899,905,906,912,913,919,920,926,927,933,934,940,941,947,948,954,955,961,962,968,969,975,976,982,983,989,990,996,997,1003,1004,1010,1011,1017];
// //                             let current_value1 = 0;
// // let videoPlacementIndexes = [];

// // while (current_value1 < 1000) { // Use 303 as the limit based on the given series
// //     for (let i = 0; i < 1; i++) { // Increment by 1
// //         current_value1 += 1;
// //         videoPlacementIndexes.push(current_value1);
// //     }
// //     for (let i = 0; i < 1; i++) { // Increment by 1 again
// //         current_value1 += 1;
// //         videoPlacementIndexes.push(current_value1);
// //     }
// //     for (let i = 0; i < 1; i++) { // Increment by 6
// //         current_value1 += 6;
// //         videoPlacementIndexes.push(current_value1);
// //     }
//     // for (let i = 0; i < 1; i++) { // Increment by 1
//     //     current_value1 += 1;
//     //     videoPlacementIndexes.push(current_value1);
//     // }
//     // for (let i = 0; i < 1; i++) { // Increment by 1 again
//     //     current_value1 += 1;
//     //     videoPlacementIndexes.push(current_value1);
//     // }
//     // for (let i = 0; i < 1; i++) { // Increment by 6
//     //     current_value1 += 6;
//     //     videoPlacementIndexes.push(current_value1);
//     // }
// // }

// // Adjust the limit and pattern to stop at the correct value
// // videoPlacementIndexes = videoPlacementIndexes.filter(index => index <= 1000);

// // console.log(videoPlacementIndexes);

//                             // let largeImagePlacementIndexes = [0, 6, 7, 14, 20, 21, 27, 28, 34, 35, 41, 42, 48, 49, 55, 56, 62, 63, 69, 70, 76, 77, 83, 84, 90, 91, 97, 98, 104, 105, 111, 112, 118, 119, 125, 126, 132, 133, 139, 140, 146, 147, 153, 154, 160, 161, 167, 168, 174, 175, 181, 182, 188, 189, 195, 196, 202, 203, 209, 210, 216, 217, 223, 224,230,231,237,238,244,245,251,252,258,259,265,266,272,273,279,280,286,287,293,294,300,301];
//                             let largeImagePlacementIndexes = [0, 6, 7, 14];
// const increments1 = [6, 1];
// let current_value2 = 14;

// while (current_value2 < 1000) {
//     for (let increments of increments1) {
//         current_value2 += increments;
//         if (current_value2 > 1000) {
//             break;
//         }
//         largeImagePlacementIndexes.push(current_value2);
//     }
// }

// console.log(largeImagePlacementIndexes);
            
//                             // Separate videos, images, and large images based on type and size_flag
//                             for (const row of result) {
//                                 if (row.image_audio_type === 3) { // Video
//                                     videos.push({
//                                         musa_image_id: row.musa_image_id,
//                                         size_flag: row.size_flag,
//                                         size_flag_text: '0=normal,1=lengthy',
//                                         image_audio_type: row.image_audio_type,
//                                         image_audio_type_text: '1=image,3=video',
//                                         image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                                         thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
//                                     });
//                                 } else if (row.image_audio_type === 1) { // Image
//                                     if (row.size_flag === 1) {
//                                         largeImages.push({
//                                             musa_image_id: row.musa_image_id,
//                                             size_flag: row.size_flag,
//                                             size_flag_text: '0=normal,1=lengthy',
//                                             image_audio_type: row.image_audio_type,
//                                             image_audio_type_text: '1=image,3=video',
//                                             image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                                             thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
//                                         });
//                                     } else {
//                                         images.push({
//                                             musa_image_id: row.musa_image_id,
//                                             size_flag: row.size_flag,
//                                             size_flag_text: '0=normal,1=lengthy',
//                                             image_audio_type: row.image_audio_type,
//                                             image_audio_type_text: '1=image,3=video',
//                                             image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                                             thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
//                                         });
//                                     }
//                                 }
//                             }
            
//                             // Initialize finalArr with 'NA' for all specified indexes
//                             let maxIndex = Math.max(...videoPlacementIndexes, ...largeImagePlacementIndexes, ...normalPlacementIndexes);
//                             let finalArr = new Array(maxIndex + 1).fill('NA');
            
//                             // Place videos at specific indexes
//                             videos.forEach((video, index) => {
//                                 if (index < videoPlacementIndexes.length) {
//                                     finalArr[videoPlacementIndexes[index]] = video;
//                                 }
//                             });
            
//                             // Place large images at specific indexes
//                             largeImages.forEach((image, index) => {
//                                 if (index < largeImagePlacementIndexes.length) {
//                                     finalArr[largeImagePlacementIndexes[index]] = image;
//                                 }
//                             });
            
//                             // Place other images in the remaining slots
//                             images.forEach((image, index) => {
//                                 if (index < normalPlacementIndexes.length) {
//                                     finalArr[normalPlacementIndexes[index]] = image;
//                                 }
//                             });
            
//                             // Trim 'NA' from the end if no images or videos exist after the last defined index
//                             while (finalArr.length > 0 && finalArr[finalArr.length - 1] === 'NA') {
//                                 finalArr.pop();
//                             }
            
//                             resolve(finalArr);
//                         }
//                     });
//                 });
//             }
            
async function getMusavideoImage(musa_id, user_id) {
    const sqlSelect = "SELECT mim.musa_image_id, mim.image_audio, mim.thumbnail_image,mim.musa_id, mim.user_id, mim.type, mim.image_audio_type, mim.size_flag,mim.duration FROM musa_image_master as mim , musa_master as mm WHERE mim.musa_id = ? AND mim.user_id = ? and mim.image_audio_type=1 and mm.delete_flag=0 and mim.musa_id=mm.musa_id";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                let videos = [];
                let images = [];
                // let largeImages = [];
              
                // const increments = [1, 1, 5];

                let normalPlacementIndexes = [0,3, 4, 5,6,7, 10, 11, 12, 13,14,17,18,19,20,21,24,25,26,27,28,31,32,33,34,35,38,39,40,41,42,45,46,47,48,49,52,53,54,55,56,59,60,61,62,63,66,67,68,69,70,73,74,75,76,77,80,81,82,83,84,87,88,89,90,91,94,95,96,97,98,101,102,103,104,105,108,109,110,111,112,115,116,117,118,119,122,123,124,125,126,129,130,131,132,133,136,137,138,139,140,143,144,145,146,147,150,151,152,153,124,157,158,159,160,161,164,165,166,167,168,171,172,173,174,175];

                let videoPlacementIndexes = [1, 2, 8, 9, 15, 16, 22, 23, 29, 30, 36, 37, 43, 44, 50, 51, 57, 58, 64, 65, 71, 72, 78, 79, 85, 86, 92, 93, 99, 100, 106, 107, 113, 114, 120, 121, 127, 128, 134, 135, 141, 142, 148, 149, 155, 156, 162, 163, 169, 170, 176, 177, 183, 184, 190, 191, 197, 198, 204, 205, 211, 212, 218, 219, 225, 226, 232,233,239,240,246,247,253,254,260,261,267,268,274,275,281,282,288,289,295,296,302,303,309,310,316,317,323,324,330,331,337,343,344,350,351,357,358,364,365,371,372,378,379,385,386,392,393,399,400,406,407,413,414,420,421,427,428,434,435,441,442,448,449,455,456,462,463,469,470,476,477,483,484,490,491,497,498,504,505,511,512,518,519,525,526,532,533,539,540,546,547,553,554,560,561,567,568,574,575,581,582,588,589,595,596,602,603,609,610,616,617,623,624,630,631,637,638,644,645,651,652,658,659,665,666,672,673,679,680,686,687,693,694,700,701,707,708,714,715,721,722,728,729,735,736,742,743,749,750,756,757,763,764,770,771,777,778,784,785,791,792,798,799,805,806,812,813,819,820,826,827,833,834,840,841,847,848,856,857,863,864,870,871,877,878,884,885,891,892,898,899,905,906,912,913,919,920,926,927,933,934,940,941,947,948,954,955,961,962,968,969,975,976,982,983,989,990,996,997,1003,1004,1010,1011,1017];



                // Separate videos, images, and large images based on type and size_flag
                for (const row of result) {
                    if (row.image_audio_type === 3) { // Video
                        videos.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            size_flag: row.size_flag,
                            size_flag_text: '0=normal,1=lengthy',
                            image_audio_type: row.image_audio_type,
                            image_audio_type_text: '1=image,3=video',
                            image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
                        });
                    } 
                         else {
                            images.push({
                                musa_image_id: row.musa_image_id,
                                duration: row.duration,
                                size_flag: row.size_flag,
                                size_flag_text: '0=normal,1=lengthy',
                                image_audio_type: row.image_audio_type,
                                image_audio_type_text: '1=image,3=video',
                                image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                                thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
                            });
                      
                    }
                }

                // Initialize finalArr with 'NA' for all specified indexes
                let maxIndex = Math.max(...videoPlacementIndexes, ...normalPlacementIndexes);
                let finalArr = new Array(maxIndex + 1).fill('NA');

                // Place videos at specific indexes
                videos.forEach((video, index) => {
                    if (index < videoPlacementIndexes.length) {
                        finalArr[videoPlacementIndexes[index]] = video;
                    }
                });


                // Place other images in the remaining slots
                images.forEach((image, index) => {
                    if (index < normalPlacementIndexes.length) {
                        finalArr[normalPlacementIndexes[index]] = image;
                    }
                });

                // Trim 'NA' from the end if no images or videos exist after the last defined index
                while (finalArr.length > 0 && finalArr[finalArr.length - 1] === 'NA') {
                    finalArr.pop();
                }

                resolve(finalArr);
            }
        });
    });
}
            
 

        async function getMusaAudio(musa_id, user_id) {
            const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`size_flag`,`duration`  FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
            return new Promise((resolve, reject) => {
                connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
                    if (err) {
                        reject(err);
                    } else {
                        let musa_audio_arr = [];
                   
                        for (const row of result) 
                            if(row.image_audio_type === 2){
                                musa_audio_arr.push({
                                    musa_image_id: row.musa_image_id,
                                    duration: row.duration,
                                    image_audio_type: row.image_audio_type,
                                    size_flag: row.size_flag,
                                    image_audio_new: row.image_audio,
                                    image_audio: process.env.IMAGE_URL+row.image_audio,
                                });
                            }
                        }
                        if(musa_audio_arr.length <= 0){
                            musa_audio_arr = "NA";
                        }
        
                        resolve(musa_audio_arr);
                    });
                })
            }
    


// get user follow status start

async function getFollowStatus(user_id,other_user_id){
    var sqlstatus = "SELECT user_id,other_user_id from contributor_follow_master where user_id= ? AND other_user_id = ? AND delete_flag = 0";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [user_id,other_user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0)
                  resolve(1);
                else
                  resolve(0);
            }
        });
    });
}
// get user follow status end


async function getlikeStatus(musa_id,user_id){
    var sqlstatus = "SELECT user_id,type from musa_like_master where user_id= ? AND musa_id = ? AND delete_flag = 0 ";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [user_id,musa_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0)
                  resolve(1);
                else
                  resolve(0);
            }
        });
    });
}



async function getlikecount(musa_id){
    var sqlstatus = "SELECT count(like_id) as like_count from musa_like_master where  musa_id = ? AND delete_flag = 0 ";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [musa_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0)
                  resolve(result[0].like_count);
                else
                  resolve(0);
            }
        });
    });
}




async function getsaveStatus(musa_id,user_id){
    var sqlstatus = "SELECT `save_musa_id`  FROM `saved_musaa` WHERE user_id = ? AND musa_id = ? AND delete_flag = 0 ";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [user_id,musa_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0)
                  resolve(1);
                else
                  resolve(0);
            }
        });
    });
}

const getComment = (musa_id) =>{
    var sqlcheak = "SELECT comment_id, user_id, other_user_id, musa_id, comment, comment_type,createtime from comment_master where musa_id = ? AND delete_flag = 0";
    return new Promise((resolve, reject) => {
        connection.query(sqlcheak, [musa_id], async(err, result) => {
            if (err) {
                reject(err);
            } else {
                resolve(result.length);
            }
        });
    });
}

const getCommentData = (musa_id) =>{
    var sqlcheak = "SELECT comment_id, user_id, musa_id, comment, comment_type,createtime from comment_master where musa_id = ? AND delete_flag = 0";
    return new Promise((resolve, reject) => {
        connection.query(sqlcheak, [musa_id], async(err, result) => {
            if (err) {
                reject(err);
            } else {
                var comment_arr = [];
                for (const row of result) {
                    let userData = await getUserData(row.user_id);
                    comment_arr.push({
                        name: (userData? userData.name : "NA"),
                        f_name: (userData ? userData.f_name : "NA"),
                        l_name: (userData ? userData.l_name : "NA"),
                        username: (userData ? userData.username : "NA"),
                        comment_id: row.comment_id,
                        user_id: row.user_id,
                        time :row.createtime,
                        musa_id : row.musa_id,
                        comment : row.comment,
                        comment_type: row.comment_type,
                        type_label: "0 for typing type, 1 for audio",
                      
                    });
                }
                if(comment_arr.length <= 0){
                    comment_arr = "NA";
                }
                resolve(comment_arr);
            }
        });
    });
}





async function getMyMusa(user_id, response) {
    try {
        const sqlSelect = "SELECT musa_id, category, sub_category, user_id, description, type,title, createtime, updatetime FROM musa_master WHERE delete_flag = 0 ORDER BY musa_id DESC";
        const result = await new Promise((resolve, reject) => {
            connection.query(sqlSelect,async(err, result) => {
                if (err) reject(err);
                else resolve(result);
            });
        });
        var musa_data_arr = [];
        if (result.length <= 0) {
           return musa_data_arr = "NA";
        }

      
        for (const row of result) {
            let status_checked = 0;
            let display_status = await displayStatusNew(row.musa_id,row.user_id);
            if(row.user_id == user_id){
                status_checked = 1;
            }else if(display_status == 1){
                status_checked = 1;
            }
            const userData = await getUser(row.user_id);
            const  image_arr = await getMusaImage(row.musa_id,row.user_id);
            const musa_video = await getMusavideo(row.musa_id,row.user_id);
            const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
            const musa_image = await getMusaMedia(row.musa_id, row.user_id);
            const img_video = await getMusavideoImage(row.musa_id, row.user_id);
            const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
            const comment1 = await getComment(row.musa_id);
            const commentData = await getCommentData(row.musa_id)
            const musa_like_status = await getlikeStatus(row.musa_id, user_id);
            const savemusa_status = await getsaveStatus(row.musa_id, user_id);
            const like_count = await getlikecount(row.musa_id)
            const follow_staus = await getFollowStatus1(user_id, row.user_id);
            const categoryData = await getSingleAllCategoryData(row.category);
            const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
            const time = await timeAgo(row.createtime);
            const imagesAndVideos = await getMusavideoImageSingleArr(row.musa_id,row.user_id);
            const share_count  = await getShareCount(row.musa_id,response);

if(status_checked == 1){


            musa_data_arr.push({
                name: (userData) ? userData.name : "NA",
                f_name: (userData) ? userData.f_name : "NA",
                l_name: (userData) ? userData.l_name : "NA",
                image : (userData) ? userData.image : "NA",
                musa_id: row.musa_id,
                user_id: row.user_id,
                title : row.title,
                category : row.category,
                sub_category : row.sub_category,
                categoryData : categoryData[0].title,
                subCategory : subCategory[0].title,
                description: row.description,
                savemusaStatus : savemusa_status,
                savemusaStatus_lable : "0 for no , 1 for yes",
                time: time,
                image_arr : image_arr,
                musa_image: musa_image,
                musa_video : musa_video,
                musa_audio : musa_audio,
                img_video : img_video.length > 0 ? img_video : 'NA',
                img_video_new : img_video_new.length > 0 ? img_video_new : 'NA',
                imagesAndVideos : imagesAndVideos,
                type: row.type,
                type_label: "0 for public, 1 for contributor, 3 for only me",
                follow_staus: follow_staus,
                follow_staus_label: "0 - no , 1- yes ",
                like_count : like_count,
                comment: comment1,
                commentData : commentData,
                musa_like_status: musa_like_status,
                musa_like_status_label: "0 - no , 1- yes ",
                total_share : share_count,
                status : false
                // saved_status : 
            });
        }
        }
        if(musa_data_arr.length <= 0){
            musa_data_arr = "NA"
        }
        return musa_data_arr;
    } catch (err) {
        console.error(err);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err.message });
    }
}

async function getMyMusasubcategory(sub_category,user_id,limit,offset, response) {
    try {
        const sqlSelect = `SELECT musa_id, category, sub_category, user_id, description, type,title, createtime, updatetime FROM musa_master WHERE user_id = ? AND sub_category=? AND delete_flag = 0 ORDER BY musa_id DESC LIMIT ${limit} OFFSET ${offset}`;
        const result = await new Promise((resolve, reject) => {
            connection.query(sqlSelect, [user_id,sub_category], async(err, result) => {
                if (err) reject(err);
                else resolve(result);
            });
        });
        var musa_data_arr = [];
        if (result.length <= 0) {
           return musa_data_arr = "NA";
        }

      
        for (const row of result) {
            const userData = await getUser(row.user_id);
            const  image_arr = await getMusaImage(row.musa_id,row.user_id);
            const musa_video = await getMusavideo(row.musa_id,row.user_id);
            const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
            const musa_image = await getMusaMedia(row.musa_id, row.user_id);
            const img_video = await getMusavideoImage(row.musa_id, row.user_id);
            const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
            const comment1 = await getComment(row.musa_id);
            const commentData = await getCommentData(row.musa_id)
            const musa_like_status = await getlikeStatus(row.musa_id, user_id);
            const savemusa_status = await getsaveStatus(row.musa_id, user_id);
            const like_count = await getlikecount(row.musa_id)
            const follow_status = await getFollowStatus(user_id, row.user_id);
            const categoryData = await getSingleAllCategoryData(row.category);
            const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
            const time = await timeAgo(row.createtime);
            const imagesAndVideos = await getMusavideoImageSingleArr(row.musa_id,row.user_id); 
            const display_request_status = await displayStatus(row.musa_id,user_id);
            const share_count  = await getShareCount(row.musa_id,response);


            musa_data_arr.push({
                name: (userData) ? userData.name : "NA",
                f_name: (userData) ? userData.f_name : "NA",
                l_name: (userData) ? userData.l_name : "NA",
                image : (userData) ? userData.image : "NA",
                musa_id: row.musa_id,
                user_id: row.user_id,
                title : row.title,
                category : row.category,
                sub_category : row.sub_category,
                categoryData : categoryData[0].title,
                subCategory : subCategory[0].title,
                description: row.description,
                savemusaStatus : savemusa_status,
                savemusaStatus_lable : "0 for no , 1 for yes",
                time: time,
                image_arr : image_arr,
                musa_image: musa_image,
                musa_video : musa_video,
                musa_audio : musa_audio,
                img_video : img_video.length > 0 ? img_video : 'NA',
                img_video_new : img_video_new.length > 0 ? img_video_new : 'NA',
                imagesAndVideos : imagesAndVideos,
                type: row.type,
                type_label: "0 for public, 1 for contributor, 3 for only me",
                follow_staus: follow_status,
                follow_staus_label: "0 - no , 1- yes ",
                like_count : like_count,
                comment: comment1,
                commentData : commentData,
                musa_like_status: musa_like_status,
                musa_like_status_label: "0 - no , 1- yes ",
                total_share : share_count,
                display_request_status : display_request_status,
                status : false
                // saved_status : 
            });
        }
        if(musa_data_arr.length <= 0){
            musa_data_arr = "NA"
        }
        return musa_data_arr;
    } catch (err) {
        console.error(err);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err.message });
    }
}





async function getMyMusasubcategoryOtherUser(sub_category,user_id,other_user_id,limit,offset, response) {
    try {
       
        const sqlSelect = `SELECT musa_id, category, sub_category, user_id, description, type,title, createtime, updatetime FROM musa_master WHERE user_id = ? AND sub_category=? AND delete_flag = 0 ORDER BY musa_id DESC LIMIT ${limit} OFFSET ${offset}`;
        const result = await new Promise((resolve, reject) => {
            connection.query(sqlSelect, [user_id,sub_category], async(err, result) => {
                if (err) reject(err);
                else resolve(result);
            });
        });
        var musa_data_arr = [];
        if (result.length <= 0) {
           return musa_data_arr = "NA";
        }

      
        for (const row of result) {
            const userData = await getUser(row.user_id);
            const  image_arr = await getMusaImage(row.musa_id,row.user_id);
            const musa_video = await getMusavideo(row.musa_id,row.user_id);
            const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
            const musa_image = await getMusaMedia(row.musa_id, row.user_id);
            const img_video = await getMusavideoImage(row.musa_id, row.user_id);
            const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
            const comment1 = await getComment(row.musa_id);
            const commentData = await getCommentData(row.musa_id)
            const musa_like_status = await getlikeStatus(row.musa_id, other_user_id);
            const savemusa_status = await getsaveStatus(row.musa_id, other_user_id);
            const like_count = await getlikecount(row.musa_id)
            const follow_status = await getFollowStatus(other_user_id, row.user_id);
            const categoryData = await getSingleAllCategoryData(row.category);
            const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
            const time = await timeAgo(row.createtime);
            const imagesAndVideos = await getMusavideoImageSingleArr(row.musa_id,row.user_id); 
            const display_request_status = await displayStatus(row.musa_id,other_user_id);
            const share_count  = await getShareCount(row.musa_id,response);


            musa_data_arr.push({
                name: (userData) ? userData.name : "NA",
                f_name: (userData) ? userData.f_name : "NA",
                l_name: (userData) ? userData.l_name : "NA",
                image : (userData) ? userData.image : "NA",
                musa_id: row.musa_id,
                user_id: row.user_id,
                title : row.title,
                category : row.category,
                sub_category : row.sub_category,
                categoryData : categoryData[0].title,
                subCategory : subCategory[0].title,
                description: row.description,
                savemusaStatus : savemusa_status,
                savemusaStatus_lable : "0 for no , 1 for yes",
                time: time,
                image_arr : image_arr,
                musa_image: musa_image,
                musa_video : musa_video,
                musa_audio : musa_audio,
                img_video : img_video,
                img_video_new : img_video_new,
                imagesAndVideos : imagesAndVideos,
                type: row.type,
                type_label: "0 for public, 1 for contributor, 3 for only me",
                follow_staus: follow_status,
                follow_staus_label: "0 - no , 1- yes ",
                like_count : like_count,
                comment: comment1,
                commentData : commentData,
                musa_like_status: musa_like_status,
                musa_like_status_label: "0 - no , 1- yes ",
                total_share : share_count,
                display_request_status : display_request_status,
                status : false
                // saved_status : 
            });
        }
        if(musa_data_arr.length <= 0){
            musa_data_arr = "NA"
        }
        return musa_data_arr;
    } catch (err) {
        console.error(err);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err.message });
    }
}

async function getsicialMyMusa(user_id, other_user, response) {
    try {
        const sqlSelect = "SELECT musa_id, category, sub_category, user_id, description, type,title, createtime, updatetime FROM musa_master WHERE type = 0 AND user_id = ? AND delete_flag = 0 ORDER BY musa_id DESC";
        const result = await new Promise((resolve, reject) => {
            connection.query(sqlSelect, [user_id], (err, result) => {
                if (err) reject(err);
                else resolve(result);
            });
        });
        var musa_data_arr = [];
        if (result.length <= 0) {
           return musa_data_arr = "NA";
        }

      
        for (const row of result) {
            const userData = await getUser(row.user_id);
            const  image_arr = await getMusaImage(row.musa_id,row.user_id);
            const musa_video = await getMusavideo(row.musa_id,row.user_id);
            const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
            const musa_image = await getMusaMedia(row.musa_id, row.user_id);
            const display_request_status = await displayStatus(row.musa_id,other_user);
            const img_video = await getMusavideoImage(row.musa_id, row.user_id);
            const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
            const comment1 = await getComment(row.musa_id);
            const commentData = await getCommentData(row.musa_id)
            const musa_like_status = await getlikeStatus(row.musa_id, other_user);
            const savemusa_status = await getsaveStatus(row.musa_id, other_user);
            const like_count = await getlikecount(row.musa_id)
            const follow_staus = await getFollowStatus(user_id, row.user_id);
            const categoryData = await getSingleAllCategoryData(row.category);
            const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
            const time = await timeAgo(row.createtime);
            const share_count  = await getShareCount(row.musa_id,response);

            musa_data_arr.push({
                img_video : img_video.length > 0 ? img_video :'NA',
                img_video_new : img_video_new.length > 0 ? img_video_new : 'NA',
                name: (userData) ? userData.name : "NA",
                f_name: (userData) ? userData.f_name : "NA",
                l_name: (userData) ? userData.l_name : "NA",
                image : (userData) ? userData.image : "NA",
                musa_id: row.musa_id,
                user_id: row.user_id,
                title : row.title,
                categoryData : categoryData[0].title,
                subCategory : subCategory[0].title,
                description: row.description,
                savemusaStatus : savemusa_status,
                savemusaStatus_lable : "0 for no , 1 for yes",
                time: time,
                image_arr : image_arr,
                musa_image: musa_image,
                musa_video : musa_video,
                musa_audio : musa_audio,
                type: row.type,
                type_label: "0 for public, 1 for contributor, 3 for only me",
                follow_staus: follow_staus,
                follow_staus_label: "0 - no , 1- yes ",
                like_count : like_count,
                comment: comment1,
                commentData : commentData,
                musa_like_status: musa_like_status,
                musa_like_status_label: "0 - no , 1- yes ",
                display_request_status : display_request_status,
                total_share : share_count,
                // saved_status : 
            });
        }
        if(musa_data_arr.length <= 0){
            musa_data_arr = "NA"
        }
        return musa_data_arr;
    } catch (err) {
        console.error(err);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err.message });
    }
}





async function getMusaMedia(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
               
                var url = "https://d38i924xuvvpvh.cloudfront.net/images/"
                let musa_image_arr = [];
              
           
                for (const row of result) {
                    if (row.image_audio_type === 1) {
                        musa_image_arr.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            image_audio:url+row.image_audio,
                        });
                    } 
                }

                if (musa_image_arr.length === 0) {
                    musa_image_arr = "NA";
                }

            
             
                resolve(musa_image_arr);
            }
        });
    });
}



async function getMusaImage(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
               
                var url = "https://d38i924xuvvpvh.cloudfront.net/images/"
                let musa_image_arr = [];
              
           
                for (const row of result) {
                    if (row.image_audio_type === 1) {
                        musa_image_arr.push(
                            url+row.image_audio,
                        );
                    } 
                }

                if (musa_image_arr.length === 0) {
                    musa_image_arr = "NA";
                }

            
             
                resolve(musa_image_arr);
            }
        });
    });
}

async function getMusaAudio(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`size_flag`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
               
                var url = "https://d38i924xuvvpvh.cloudfront.net/images/"
                let musa_audio_arr = [];
              
           
                for (const row of result) {
                    if (row.image_audio_type === 2) {
                        musa_audio_arr.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            image_audio_new: row.image_audio,
                            image_audio_type: row.image_audio_type,
                            size_flag: row.size_flag,
                            name:url+row.image_audio,
                        });
                    } 
                }

                if (musa_audio_arr.length === 0) {
                    musa_audio_arr = "NA";
                }

            
             
                resolve(musa_audio_arr);
            }
        });
    });
}


async function getMusavideo(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ?";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
               
                var url = "https://d38i924xuvvpvh.cloudfront.net/images/"
                let musa_video_arr = [];
              
           
                for (const row of result) {
                    if (row.image_audio_type === 3) {
                        musa_video_arr.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            image_audio:url+row.image_audio,
                            thumbnail_image: "https://d38i924xuvvpvh.cloudfront.net/"+row.thumbnail_image,
                        });
                    } 
                }

                if (musa_video_arr.length === 0) {
                    musa_video_arr = "NA";
                }

            
             
                resolve(musa_video_arr);
            }
        });
    });
}


async function timeAgo(dateTime) {
    const timestamp = moment(dateTime); 
    const currentTime = moment();

    if (!timestamp.isValid()) {
        return 'Invalid date';
    }

    const diffSeconds = currentTime.diff(timestamp, 'seconds');

    if (diffSeconds < 60) {
        return diffSeconds + ' seconds ago';
    }

    const diffMinutes = currentTime.diff(timestamp, 'minutes');

    if (diffMinutes < 60) {
        return diffMinutes + ' minutes ago';
    }

    const diffHours = currentTime.diff(timestamp, 'hours');

    if (diffHours < 24) {
        return diffHours + ' hours ago';
    }

    const diffDays = currentTime.diff(timestamp, 'days');

    if (diffDays < 30) {
        return diffDays + ' days ago';
    }

    const diffMonths = currentTime.diff(timestamp, 'months');

    if (diffMonths < 12) {
        return diffMonths + ' months ago';
    }

    const diffYears = currentTime.diff(timestamp, 'years');
    return diffYears + ' years ago';
}



async function getSavedMusa(user_id) {
    try {
        const sqlsave = "SELECT save_musa_id, musa_id, type, user_id FROM saved_musaa WHERE user_id = ? AND delete_flag = 0";
        const resultData = await new Promise((resolve, reject) => {
            connection.query(sqlsave, [user_id], (err, resultData) => {
                if (err) reject(err);
                else resolve(resultData);
            });
        });


      
        // return resultData;
        let saved_musa_data_arr = [];
        for (const result1 of resultData) {
            const sqlSelect = "SELECT musa_id, category, sub_category, user_id,title, description, type, createtime, updatetime FROM musa_master WHERE  musa_id = ? AND delete_flag = 0 ORDER BY musa_id DESC";
            const data = await new Promise((resolve, reject) => {
                connection.query(sqlSelect, [result1.musa_id], (err, data1) => {
                    if (err) reject(err);
                    else resolve(data1);
                });
            });

            for (const row of data) {
                const userData = await getUser(row.user_id);
                const imagesAndVideos = await getMusavideoImageSingleArr(row.musa_id,row.user_id);
                const  image_arr = await getMusaImage(row.musa_id,row.user_id);
                const musa_video = await getMusavideo(row.musa_id,row.user_id);
                const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
                const musa_image = await getMusaMedia(row.musa_id, row.user_id);
                const comment1 = await getComment(row.musa_id);
                const followstatus = await getFollowStatus1(user_id, row.user_id);
                const img_video = await getMusavideoImage(row.musa_id, row.user_id);
                const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
                const commentData = await getCommentData(row.musa_id);
                const musa_like_status = await getlikeStatus(row.musa_id, user_id);
                const savemusa_status = await getsaveStatus(row.musa_id, user_id);
                const like_count = await getlikecount(row.musa_id);
                const follow_staus = await getFollowStatus(user_id, row.user_id);
                const categoryData = await getSingleAllCategoryData(row.category);
                const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
                const time = await timeAgo(row.createtime);
                const display_request_status = await displayStatus(row.musa_id,user_id);
                const share_count  = await getShareCount(row.musa_id,response);
                
                saved_musa_data_arr.push({
                    name: (userData) ? userData.name : "NA",
                    f_name: (userData) ? userData.f_name : "NA",
                    l_name: (userData) ? userData.l_name : "NA",
                    image : (userData) ? userData.image : "NA",
                    musa_id: row.musa_id,
                    user_id: row.user_id,
                    title : row.title,
                    category : row.category,
                    sub_category : row.sub_category,
                    categoryData : categoryData[0].title,
                    subCategory : subCategory[0].title,
                    description: row.description,
                    savemusaStatus : savemusa_status,
                    savemusaStatus_lable : "0 for no , 1 for yes",
                    time: time,
                    image_arr : image_arr,
                    musa_image: musa_image,
                    musa_video : musa_video,
                    musa_audio : musa_audio,
                    type: row.type,
                    type_label: "0 for public, 1 for contributor, 3 for only me",
                    follow_staus: follow_staus,
                    follow_staus_label: "0 - no , 1- yes ",
                    like_count : like_count,
                    comment: comment1,
                    commentData : commentData,
                    musa_like_status: musa_like_status,
                    musa_like_status_label: "0 - no , 1- yes ",
                    total_share : share_count,
                    img_video : img_video,
                    img_video_new : img_video_new,
                    imagesAndVideos : imagesAndVideos,
                    display_request_status : display_request_status,
                    follow_staus: (followstatus ) ? followstatus : 0,
                    follow_staus_label: "0 - no , 1- yes ",
                    status : false
                });
            }
        }
        
        if (saved_musa_data_arr.length <= 0) {
            saved_musa_data_arr = "NA";
        }
        
        return saved_musa_data_arr;
    } catch (error) {
        console.error("Error in getSavedMusa:", error.message);
        return "Error occurred while fetching saved musa data", error.message;
    }
}


function generateOTP(limit) {
    var digits = '0123456789';
    let OTP = '';
    for (let i = 0; i < limit; i++ ) {
        OTP += digits[Math.floor(Math.random() * 10)];
    }
    return OTP;
}

async function getUser(userId) {
    return new Promise((resolve, reject) => {
      const query1 = "SELECT  `user_id`, `login_type`, `login_type_first`, `user_type`, `email`, `password`, `username`, `f_name`, `l_name`, `name`, `dob`, `age`, `phone_code`, `mobile`, `otp`, `otp_verify`, `image`, `gender`, `address`, `latitude`, `longitude`, `zipcode`, `bio`, `bio_type`, `active_flag`, `approve_flag`, `profile_complete`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`, `notification_status`, `delete_flag`, `delete_reason`, `createtime`, `updatetime`, `mysqltime`, `signup_step`, `avatar_id`, `currect_location_permanent`, `about` FROM user_master WHERE user_id = ? and delete_flag=0";
  
      connection.query(query1, [userId], async (error, results) => {
        if (error) {
          reject(error);
          return;
        }
  
        if (results.length > 0) {
          const user = results[0];  
          try {
            const userDataArray = {
              user_id: user.user_id,
              login_type: user.login_type,
              login_type_first: user.login_type_first,
              user_type: user.user_type,
              email: user.email,
              username : user.username,
              f_name: user.f_name,
              l_name: user.l_name,
              name: user.name,
              dob: user.dob,
              age: user.age,
              phone_code: user.phone_code,
              mobile: user.mobile,
              otp: user.otp,
              otp_verify: user.otp_verify,
              image: user.image,
              gender: user.gender,
              address: user.address,
              latitude: user.latitude,
              longitude: user.longitude,
              zipcode : user.zipcode,
              active_flag: user.active_flag,
              approve_flag: user.approve_flag,
              profile_complete: user.profile_complete,
              language_id: user.language_id,
              facebook_id: user.facebook_id,
              google_id: user.google_id,
              apple_id: user.apple_id,
              notification_status: user.notification_status,
              delete_reason: user.delete_reason,
              createtime: user.createtime,
              updatetime: user.updatetime,
              bio: user.bio,
              bio_type : user.bio_type,
              signup_step: user.signup_step,
              about : user.about,
            };
            resolve(userDataArray);
          } catch (err) {
            reject(err);
          }
        } else {
          resolve(null);
        }
      });
    });
  }



// only images and videos start

async function getMusavideoImageSingleArr(musa_id, user_id) {
    const sqlSelect = "SELECT `musa_image_id`, `image_audio`, `thumbnail_image`, `musa_id`, `user_id`, `type`, `image_audio_type`, `size_flag`,`duration` FROM `musa_image_master` WHERE musa_id = ? AND user_id = ? and (image_audio_type = 1 OR image_audio_type=3)";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [musa_id, user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                let videos = [];
                let images = [];
                
                // Separate videos, images, and large images based on type and size_flag
                for (const row of result) {
                    if (row.image_audio_type == 3) { // Video
                        videos.push({
                            musa_id: row.musa_id,
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            size_flag: row.size_flag,
                            size_flag_text: '0=normal,1=lengthy',
                            image_audio_type: row.image_audio_type,
                            image_audio_type_text: '1=image,3=video',
                            image_audio: row.image_audio,
                            thumbnail_image_audio: row.thumbnail_image,
                            path: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
                        });
                    } else if (row.image_audio_type == 1) { // Image
                        images.push({
                            musa_id: row.musa_id,
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            size_flag: row.size_flag,
                            size_flag_text: '0=normal,1=lengthy',
                            image_audio_type: row.image_audio_type,
                            image_audio_type_text: '1=image,3=video',
                            image_audio: row.image_audio,
                            thumbnail_image_audio: row.thumbnail_image,
                            path: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
                        });
                    }
                }

                // Initialize final array and push images first, then videos
                let finalArr = [];
                if(images.length > 0){
                    finalArr.push(...images);
                }
                if(videos.length > 0){
                    finalArr.push(...videos);
                }
               
                if(finalArr.length <= 0){
                    finalArr = 'NA';
                }
            
                resolve(finalArr);
            }
        });
    });
}



// only images and videos end

// get categories sub categories start

// get my musa according to subcategories start

const getAllMusaAccToSubCategories = async (request,response) => {

    const{sub_category_id,user_id,offset} = request.query;

    try {
        
        if (!user_id) {
            return response.status(400).json({ success: false, msg: languageMessages.msg_empty_param, key: "user_id" });
        }
        if (!sub_category_id) {
            return response.status(400).json({ success: false, msg: languageMessages.msg_empty_param, key: "sub_category_id" });
        }

        const sqlCheck = "SELECT user_id, active_flag, f_name FROM user_master WHERE user_id = ? AND delete_flag = 0";
        connection.query(sqlCheck, [user_id], (err, result) => {
            if (err) {
                return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err });
            }

            if (result.length <= 0) {
                return response.status(404).json({ success: false, msg: languageMessages.msgUserNotFound });
            }

            if (result[0].active_flag === 0) {
                return response.status(403).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });
            }

            const getAllMusa = "SELECT `musa_id`, `category`, `sub_category`, `user_id`, `description`, `title`, `type` FROM `musa_master` WHERE delete_flag = 0 and user_id = ? and sub_category = ? ";
            connection.query(getAllMusa,[user_id,sub_category_id],async(getErr,getResult)=>{

                if(getErr){
                    return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: getErr });
                }else{

                    if(getResult.length > 0){

                        const userData = await getUserData(user_id);

                        let limit = 5;
                        const mymusaData = await getMyMusasubcategory(sub_category_id,user_id,limit,offset, response);
                      
                        let loadmore = mymusaData.length >= limit ? true : false;
                       
if(mymusaData != 'NA'){
    var profile_data = {

        name :(userData) ?  userData.name : "NA",

        f_name :(userData) ? userData.f_name : "NA",

        l_name :(userData) ? userData.l_name : "NA",

        image : (userData) ? userData.image : "NA",

        bio :(userData) ? userData.bio : "NA",

        age :(userData) ? userData.age : "NA",

        email :(userData) ? userData.email : "NA",

        mymusaData : mymusaData,

    }  

    return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: profile_data,loadmore:loadmore});
}

return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: 'NA',loadmore:loadmore});
                       
                     
                    }else{
                        return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: 'NA' ,loadmore:loadmore});
                    }
                }
            })

        });

    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error });
    }

} 

// get my musa according to subcategories end

const getOtherUserAllMusaAccToSubCategories = async (request,response) => {

    const{sub_category_id,user_id,other_user_id,offset} = request.query;

    try {
        
        if (!user_id) {
            return response.status(400).json({ success: false, msg: languageMessages.msg_empty_param, key: "user_id" });
        }
        if (!sub_category_id) {
            return response.status(400).json({ success: false, msg: languageMessages.msg_empty_param, key: "sub_category_id" });
        }

        const sqlCheck = "SELECT user_id, active_flag, f_name FROM user_master WHERE user_id = ? AND delete_flag = 0";
        connection.query(sqlCheck, [user_id], (err, result) => {
            if (err) {
                return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err });
            }

            if (result.length <= 0) {
                return response.status(404).json({ success: false, msg: languageMessages.msgUserNotFound });
            }

            if (result[0].active_flag === 0) {
                return response.status(403).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });
            }

            let limit = 5;
            const getAllMusa =`SELECT musa_id, category, sub_category, user_id, description, title, type FROM musa_master WHERE delete_flag = 0 and user_id = ? and sub_category = ? `;
            connection.query(getAllMusa,[other_user_id,sub_category_id],async(getErr,getResult)=>{

                if(getErr){
                    return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: getErr });
                }else{

                    if(getResult.length > 0){

                        const userData = await getUserData(other_user_id);
                        let limit = 5;
                        const mymusaData = await getMyMusasubcategoryOtherUser(sub_category_id,other_user_id,user_id,limit,offset,response);
                        let loadmore = mymusaData.length >= limit ? true : false;
if(mymusaData != 'NA'){
    var profile_data = {

        name :(userData) ?  userData.name : "NA",

        f_name :(userData) ? userData.f_name : "NA",

        l_name :(userData) ? userData.l_name : "NA",

        image : (userData) ? userData.image : "NA",

        bio :(userData) ? userData.bio : "NA",

        age :(userData) ? userData.age : "NA",

        email :(userData) ? userData.email : "NA",

        mymusaData : mymusaData,
    }  


   
    
    return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: profile_data,loadmore:loadmore});
}
return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data:  'NA',loadmore:loadmore});  
                     
                    }else{
                        return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: 'NA',loadmore:loadmore });
                    }
                }
            })

        });

    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error });
    }

}


// get display request status start

async function displayStatusNew(musa_id,user_id){

    const display = "SELECT status FROM display_request_master WHERE delete_flag=0 and musa_id=? and user_id=? and status=1 order by request_id desc";
    return new Promise((resolve,reject)=>{
        connection.query(display,[musa_id,user_id],async(err,result)=>{
            if(err){
                reject(err);
            }else{
                if(result.length > 0){
                    resolve(1);
                }else{
                    resolve(0);
                }
                
            }
        })
    })

}

// get display request status end

// share count start

async function getShareCount(musa_id,response) {

    try {
        const sql = "SELECT share_count FROM musa_master WHERE delete_flag=0 and musa_id=?";
        let result = await new Promise((resolve,reject)=>{
          connection.query(sql,[musa_id],async(err,result1)=>{
            if(err){
                reject(err);
            }else{
                resolve(result1);
            }
          })
        })
let share_count = result[0].share_count;
        return share_count;


    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error });
    }
  
}

// share count end

async function getSavedMusaNew(user_id, response) {
    try {
        const sqlsave = "SELECT save_musa_id, musa_id, type, user_id FROM saved_musaa WHERE user_id = ? AND delete_flag = 0";
        const resultData = await new Promise((resolve, reject) => {
            connection.query(sqlsave, [user_id], (err, resultData) => {
                if (err) reject(err);
                else resolve(resultData);
            });
        });

        let saved_musa_data_arr = [];
        for (const result1 of resultData) {
            const sqlSelect = "SELECT musa_id, category, sub_category, user_id, title, description, type, createtime, updatetime FROM musa_master WHERE musa_id = ? AND delete_flag = 0 ORDER BY musa_id DESC";
            const data = await new Promise((resolve, reject) => {
                connection.query(sqlSelect, [result1.musa_id], (err, data1) => {
                    if (err) reject(err);
                    else resolve(data1);
                });
            });

            for (const row of data) {
                const [
                    userData,
                    imagesAndVideos,
                    image_arr,
                    musa_video,
                    musa_audio,
                    musa_image,
                    comment1,
                    followstatus,
                    img_video,
                    img_video_new,
                    commentData,
                    musa_like_status,
                    savemusa_status,
                    like_count,
                    follow_staus,
                    categoryData,
                    subCategory,
                    time,
                    display_request_status,
                    share_count
                ] = await Promise.all([
                    getUser(row.user_id),
                    getMusavideoImageSingleArr(row.musa_id, row.user_id),
                    getMusaImage(row.musa_id, row.user_id),
                    getMusavideo(row.musa_id, row.user_id),
                    getMusaAudio(row.musa_id, row.user_id),
                    getMusaMedia(row.musa_id, row.user_id),
                    getComment(row.musa_id),
                    getFollowStatus1(user_id, row.user_id),
                    getMusavideoImage(row.musa_id, row.user_id),
                    getMusavideoNew(row.musa_id, row.user_id),
                    getCommentData(row.musa_id),
                    getlikeStatus(row.musa_id, user_id),
                    getsaveStatus(row.musa_id, user_id),
                    getlikecount(row.musa_id),
                    getFollowStatus(user_id, row.user_id),
                    getSingleAllCategoryData(row.category),
                    getSingleSubCategoryData(row.sub_category, row.category),
                    timeAgo(row.createtime),
                    displayStatus(row.musa_id, user_id),
                    getShareCount(row.musa_id)
                ]);

                saved_musa_data_arr.push({
                    name: userData ? userData.name : "NA",
                    f_name: userData ? userData.f_name : "NA",
                    l_name: userData ? userData.l_name : "NA",
                    image: userData ? userData.image : "NA",
                    musa_id: row.musa_id,
                    user_id: row.user_id,
                    title: row.title,
                    category: row.category,
                    sub_category: row.sub_category,
                    categoryData: categoryData[0].title,
                    subCategory: subCategory[0].title,
                    description: row.description,
                    savemusaStatus: savemusa_status,
                    savemusaStatus_label: "0 for no, 1 for yes",
                    time: time,
                    image_arr: image_arr,
                    musa_image: musa_image,
                    musa_video: musa_video,
                    musa_audio: musa_audio,
                    type: row.type,
                    type_label: "0 for public, 1 for contributor, 3 for only me",
                    follow_status: follow_staus,
                    follow_status_label: "0 - no, 1- yes",
                    like_count: like_count,
                    comment: comment1,
                    commentData: commentData,
                    musa_like_status: musa_like_status,
                    musa_like_status_label: "0 - no, 1- yes",
                    total_share: share_count,
                    img_video: img_video,
                    img_video_new: img_video_new.length > 0 ? img_video_new : 'NA',
                    imagesAndVideos: imagesAndVideos,
                    display_request_status: display_request_status,
                    follow_status: followstatus ? followstatus : 0,
                    follow_status_label: "0 - no, 1- yes",
                    status: false
                });
            }
        }

        if (saved_musa_data_arr.length <= 0) {
            saved_musa_data_arr = "NA";
        }
       return saved_musa_data_arr;
    } catch (error) {
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error });
    }
}

// get used gb size in musa start

async function getUsedGb(user_id) {
    return new Promise((resolve,reject)=>{
        let sql = "SELECT SUM(mim.size) as size FROM musa_master as mm,musa_image_master as mim where mm.delete_flag=0 and mm.user_id=? and mm.musa_id=mim.musa_id and mim.delete_flag=0 and mm.delete_flag=0";
        connection.query(sql,[user_id],async(err,result)=>{
            if(err){
                reject(err)
            }else{
                if(result.length > 0){
                    resolve(result[0].size);
                }else{
                    resolve(0);
                }
            }
        })
    })
}

// get used gb size in musa end


async function totalGb(user_id) {
    
    let sql = "SELECT SUM(gb) as total_gb FROM plan_master as pm , user_plan_master as upm WHERE upm.plan_id=pm.plan_id and upm.delete_flag=0 and upm.user_id=?";

    return new Promise(async(resolve,reject)=>{
        await connection.query(sql,[user_id],async(err,result)=>{
            if(err){
                resolve(0);
            }else{
                if(result.length > 0){
                    resolve(result[0].total_gb);
                }else{
                    resolve(0)
                }
            }
        })
    })

}
   

async function getMyMusaNew(user_id,limit,offset, response) {
    try {
        // const sqlSelect = `SELECT musa_id, category, sub_category, user_id, description, type,title, createtime, updatetime FROM musa_master WHERE delete_flag = 0 ORDER BY musa_id DESC LIMIT ${limit} OFFSET ${offset}`;
        const sqlSelect = `
  SELECT mm.musa_id, mm.category, mm.sub_category, mm.user_id, mm.description, mm.type, mm.title, mm.createtime, mm.updatetime 
  FROM musa_master AS mm 
  LEFT JOIN display_request_master AS drm ON mm.musa_id = drm.musa_id 
  WHERE mm.delete_flag = 0 
  AND (
    mm.user_id = ${user_id} 
    OR (
      drm.status = 1 
      AND drm.user_id = ${user_id} 
      AND drm.musa_id = mm.musa_id
    )
  )
  ORDER BY mm.musa_id DESC 
  LIMIT ${limit} OFFSET ${offset}
`;

        const result = await new Promise((resolve, reject) => {
            connection.query(sqlSelect,async(err, result) => {
                if (err) reject(err);
                else resolve(result);
            });
        });
        var musa_data_arr = [];
        if (result.length <= 0) {
           return musa_data_arr = "NA";
        }

      
        for (const row of result) {
            let status_checked = 0;
            let display_status = await displayStatusNew(row.musa_id,row.user_id);
            if(row.user_id == user_id){
                status_checked = 1;
            }else if(display_status == 1){
                status_checked = 1;
            }
            const userData = await getUser(row.user_id);
            const  image_arr = await getMusaImage(row.musa_id,row.user_id);
            const musa_video = await getMusavideo(row.musa_id,row.user_id);
            const musa_audio = await getMusaAudio(row.musa_id,row.user_id);
            const musa_image = await getMusaMedia(row.musa_id, row.user_id);
            const img_video = await getMusavideoImage(row.musa_id, row.user_id);
            const img_video_new = await getMusavideoNew(row.musa_id, row.user_id);
            const comment1 = await getComment(row.musa_id);
            const commentData = await getCommentData(row.musa_id)
            const musa_like_status = await getlikeStatus(row.musa_id, user_id);
            const savemusa_status = await getsaveStatus(row.musa_id, user_id);
            const like_count = await getlikecount(row.musa_id)
            const follow_staus = await getFollowStatus1(user_id, row.user_id);
            const categoryData = await getSingleAllCategoryData(row.category);
            const subCategory = await getSingleSubCategoryData(row.sub_category,row.category);
            const time = await timeAgo(row.createtime);
            const imagesAndVideos = await getMusavideoImageSingleArr(row.musa_id,row.user_id);
            const share_count  = await getShareCount(row.musa_id,response);

// if(status_checked == 1){


            musa_data_arr.push({
                name: (userData) ? userData.name : "NA",
                f_name: (userData) ? userData.f_name : "NA",
                l_name: (userData) ? userData.l_name : "NA",
                image : (userData) ? userData.image : "NA",
                musa_id: row.musa_id,
                user_id: row.user_id,
                title : row.title,
                category : row.category,
                sub_category : row.sub_category,
                categoryData : categoryData[0].title,
                subCategory : subCategory[0].title,
                description: row.description,
                savemusaStatus : savemusa_status,
                savemusaStatus_lable : "0 for no , 1 for yes",
                time: time,
                image_arr : image_arr,
                musa_image: musa_image,
                musa_video : musa_video,
                musa_audio : musa_audio,
                img_video : img_video.length > 0 ? img_video : 'NA',
                img_video_new : img_video_new.length > 0 ? img_video_new : 'NA',
                imagesAndVideos : imagesAndVideos,
                type: row.type,
                type_label: "0 for public, 1 for contributor, 3 for only me",
                follow_staus: follow_staus,
                follow_staus_label: "0 - no , 1- yes ",
                like_count : like_count,
                comment: comment1,
                commentData : commentData,
                musa_like_status: musa_like_status,
                musa_like_status_label: "0 - no , 1- yes ",
                total_share : share_count,
                status : false
                // saved_status : 
            });
        // }
        }
        if(musa_data_arr.length <= 0){
            musa_data_arr = "NA"
        }
        return musa_data_arr;
    } catch (err) {
        console.error(err);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: err.message });
    }
}

module.exports = {getCommentData,getMusavideo,getlikecount,fetchUserData,DeviceTokenStore_1_Signal,featchAddressData,getUserData, getMusaImage, getFollowStatus, getComment, getlikeStatus, getMyMusa, getSavedMusa,generateOTP,getsicialMyMusa,getMusavideoImage,getMusavideoImageSingleArr,getAllMusaAccToSubCategories,getOtherUserAllMusaAccToSubCategories,getShareCount,getSavedMusaNew,getMyMusaNew};