const connection = require("../connection/dbconfig");
const languageMessages = require("./languageMessages");
const axios = require("axios");
const moment = require("moment");
require("dotenv").config();

function getNotificationArrSingle(
  user_id,
  other_user_id,
  action,
  action_id,
  title,
  title_2,
  title_3,
  title_4,
  title_5,
  message,
  message_2,
  message_3,
  message_4,
  message_5,
  action_data,
  callback
) {
  const notification_arr = {};

  const action_json = JSON.stringify(action_data);

  // console.log('action_json',action_json);

  InsertNotification(
    user_id,
    other_user_id,
    action,
    action_id,
    action_json,
    title,
    title_2,
    title_3,
    title_4,
    title_5,
    message,
    message_2,
    message_3,
    message_4,
    message_5,
    (insert_status) => {
      if (insert_status === "yes") {
        // console.log('insert_status',insert_status)

        getNotificationStatus(other_user_id, (notification_status) => {
          //  console.log('notification_status',notification_status)

          if (notification_status === "yes") {
            getUserPlayerId(other_user_id, async (player_id) => {
              // console.log('player_idssss',player_id)

              if (player_id !== "no") {
                notification_arr.player_id = player_id;

                notification_arr.title = title;

                notification_arr.message = message;

                notification_arr.action_json = action_data;

                // console.log('notification_arr',notification_arr)
                await oneSignalNotificationSend(
                  title,
                  message,
                  action_json,
                  notification_arr.player_id
                );

                callback(notification_arr);
              } else {
                callback(notification_arr);
              }
            });
          } else {
            callback(notification_arr);
          }
        });
      } else {
        callback(notification_arr);
      }
    }
  );
}

function InsertNotification(
  user_id,
  other_user_id,
  action,
  action_id,
  action_json,
  title,
  title_2,
  title_3,
  title_4,
  title_5,
  message,
  message_2,
  message_3,
  message_4,
  message_5,
  callback
) {
  const read_status = "0";

  const delete_flag = "0";

  const sql =
    "INSERT INTO user_notification_message (user_id, other_user_id, action, action_id, action_json, title,title_2,title_3,title_4,title_5, message,message_2,message_3,message_4,message_5, read_status, delete_flag, createtime, updatetime) VALUES (?,?,?,?,?, ?, ?, ?, ?, ?, ?,?,?,?, ?,?, ?, now(), now())";

  connection.query(
    sql,
    [
      user_id,
      other_user_id,
      action,
      action_id,
      action_json,
      title,
      title_2,
      title_3,
      title_4,
      title_5,
      message,
      message_2,
      message_3,
      message_4,
      message_5,
      read_status,
      delete_flag,
    ],
    (error, results) => {
      if (error) {
        console.error("Error inserting notification:", error);

        callback("no");
      } else {
        callback("yes");
      }
    }
  );
}

function getNotificationStatus(user_id, callback) {
  const sql =
    "SELECT user_id FROM user_master WHERE user_id = ? AND notification_status = '1'";

  connection.query(sql, [user_id], (error, results) => {
    if (error) {
      console.error("Error getting notification status:", error);

      callback("no");
    } else {
      if (results.length > 0) {
        callback("yes");
      } else {
        callback("no");
      }
    }
  });
}

const getNotification = (request, response) => {
  const { user_id } = request.query;

  console.log(user_id, "user_id");

  try {
    // Query to check if the user exists

    var sql1 = `SELECT user_id,active_flag FROM user_master WHERE delete_flag = 0 AND user_id = ?`;

    var values1 = [user_id];

    connection.query(sql1, values1, async (err, information) => {
      if (err) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.internalServerError,
          data: {},
        });
      }

      if (information.length === 0) {
        return response
          .status(404)
          .json({ success: false, msg: languageMessages.msgUserNotFound });
      }

      // var result = await cheakUseractiveDeactive(user_id);

      if (information[0].active_flag === 0) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.accountdeactivated,
          active_status: 0,
        });
      }

      // Query to fetch notifications

      var sql =
        "SELECT um.username,um.image,um.f_name,um.l_name,unm.notification_message_id, unm.user_id, unm.other_user_id, unm.action, unm.action_id, unm.action_json, unm.title, unm.message, unm.title_2, unm.title_3, unm.title_4, unm.title_5, unm.message_2, unm.message_3, unm.message_4, unm.message_5, unm.title_ar, unm.message_arr, unm.read_status,unm.createtime FROM user_notification_message as unm , user_master as um WHERE unm.other_user_id = ? AND unm.delete_flag = 0 and um.user_id=unm.user_id ORDER BY unm.notification_message_id DESC";

      connection.query(sql, [user_id], async (err, info) => {
        if (err) {
          return response.status(200).json({
            success: false,
            msg: languageMessages.internalServerError,
            err,
          });
        }

        try {
          const dateFormatter = new Intl.DateTimeFormat("en-US", {
            day: "2-digit",
            month: "long",
            year: "numeric",
          });

          const timeFormatter = new Intl.DateTimeFormat("en-US", {
            hour: "2-digit",
            minute: "2-digit",
            hour12: true,
          });

          let notification_arr = await Promise.all(
            info.map(async (row) => {
              try {
                let date_time = calculateTimeElapsed(row.createtime);

                const date = new Date(row.createtime);

                const formattedDate = dateFormatter.format(date);

                const formattedTime = timeFormatter.format(date);

                var action_json_image = "NA";
                if (row.action === "broadcast") {
                  try {
                    const actionObject = JSON.parse(row.action_json);
                    const imageUrl = actionObject.image;
                    action_json_image = imageUrl || "NA";
                  } catch (error) {
                    console.error("Error parsing JSON:", error);
                  }
                }
                return {
                  notification_message_id: row.notification_message_id,

                  user_id: row.user_id,

                  user_image: row.image != null ? row.image : "NA",

                  other_user_id: row.other_user_id,

                  username: row.username != null ? row.username : "NA",

                  f_name: row.f_name != null ? row.f_name : "NA",

                  l_name: row.l_name != null ? row.l_name : "NA",

                  action: row.action,

                  action_id: row.action_id,

                  action_json: row.action_json,

                  action_json_image: action_json_image,

                  date_time: date_time,

                  title: row.title,

                  message: row.message,

                  read_status: row.read_status,

                  status: false,
                };
              } catch (error) {
                console.error("Error fetching user data:", error);

                throw error;
              }
            })
          );

          //update read status start

          let updatetime = moment().format("YYYY-MM-DD HH:mm:ss");
          const updateRead = `UPDATE user_notification_message SET read_status = 1, updatetime = ? WHERE delete_flag = 0 AND other_user_id = ?`;

          connection.query(
            updateRead,
            [updatetime, user_id],
            (updateError, updateReadResult) => {}
          );

          //update read status end

          if (notification_arr.length <= 0) {
            notification_arr = "NA";
          }

          return response.status(200).json({
            success: true,
            message: languageMessages.msgDataFound,
            notification_arr: notification_arr,
          });
        } catch (error) {
          console.error("Error processing notifications:", error);

          return response.status(200).json({
            success: false,
            msg: languageMessages.internalServerError,
            error_new: error,
          });
        }
      });
    });
  } catch (error) {
    console.error("Error in try block:", error);

    return response.status(200).json({
      success: false,
      msg: languageMessages.internalServerError,
      error,
    });
  }
};

function calculateTimeElapsed(timestamp) {
  const givenTime = new Date(timestamp);
  const newTime = moment().format("YYYY-MM-DD HH:mm:ss");
  const currentTime = new Date(newTime);

  const timeDifference = currentTime - givenTime;

  const seconds = Math.floor(timeDifference / 1000);
  const minutes = Math.floor(seconds / 60);
  const hours = Math.floor(minutes / 60);
  const days = Math.floor(hours / 24);
  const months = Math.floor(days / 30);
  const years = Math.floor(months / 12);

  if (years > 0) {
    return `${years} year${years > 1 ? "s" : ""} ago`;
  } else if (months > 0) {
    return `${months} month${months > 1 ? "s" : ""} ago`;
  } else if (days > 0) {
    return `${days} day${days > 1 ? "s" : ""} ago`;
  } else if (hours > 0) {
    return `${hours} hour${hours > 1 ? "s" : ""} ago`;
  } else if (minutes > 0) {
    return `${minutes} minute${minutes > 1 ? "s" : ""} ago`;
  } else {
    return `${seconds} second${seconds > 1 ? "s" : ""} ago`;
  }
}

// delete notification start

const deleteSingleNotification = (request, response) => {
  const { user_id, notification_message_id } = request.body;

  try {
    if (!user_id) {
      return response.status(200).json({
        success: false,
        msg: languageMessages.msg_empty_param,
        key: "user_id",
      });
    }

    if (!notification_message_id) {
      return response.status(200).json({
        success: false,
        msg: languageMessages.msg_empty_param,
        key: "notification_message_id",
      });
    }

    // cheak user start

    var sql1 = `SELECT user_id,active_flag FROM user_master WHERE delete_flag = 0 AND user_id = ?`;

    var values1 = [user_id];

    connection.query(sql1, values1, async (err, information) => {
      if (err) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.internalServerError,
          data: {},
        });
      }

      if (information.length === 0) {
        return response.status(404).json({
          success: false,
          msg: languageMessages.msgUserNotFound,
          data: {},
        });
      }

      // var result = await cheakUseractiveDeactive(user_id);

      if (information[0].active_flag === 0) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.accountdeactivated,
          active_status: 0,
        });
      }
    });

    // cheak user end

    var sql1 = `SELECT notification_message_id FROM user_notification_message WHERE delete_flag = 0 AND notification_message_id = ?`;

    var values1 = [notification_message_id];

    connection.query(sql1, values1, async (err, information) => {
      if (err) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.internalServerError,
          data: {},
        });
      }

      if (information.length === 0) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.NotificatiomsgDataFound,
          data: {},
        });
      }

      var sqlNotification =
        "SELECT notification_message_id,user_id FROM user_notification_message where notification_message_id = ? AND other_user_id = ?  AND delete_flag = 0";

      connection.query(
        sqlNotification,
        [notification_message_id, user_id],
        (err, result) => {
          if (err) {
            return response.status(200).json({
              success: false,
              msg: languageMessages.internalServerError,
              key: "6",
            });
          } else {
            let delete_flag = 1;

            var sqlNotification =
              "UPDATE user_notification_message SET delete_flag = ? ,updatetime= now() WHERE notification_message_id=? AND other_user_id = ? ";

            connection.query(
              sqlNotification,
              [delete_flag, notification_message_id, user_id],
              (err, result) => {
                if (err) {
                  return response.status(200).json({
                    success: false,
                    msg: languageMessages.internalServerError,
                    key: "2",
                  });
                } else {
                  return response.status(200).json({
                    success: true,
                    msg: languageMessages.notificationDelete,
                  });
                }
              }
            );
          }
        }
      );
    });
  } catch (error) {
    console.error("Error in try block:", error);

    return response
      .status(200)
      .json({ success: false, msg: languageMessages.internalServerError });
  }
};

// delete notification end

// delete All notification start

const deleteAllNotification = (request, response) => {
  const { user_id } = request.body;

  try {
    if (!user_id) {
      return response.status(200).json({
        success: false,
        msg: languageMessages.msg_empty_param,
        key: "user_id",
      });
    }

    // cheak user start

    var sql1 = `SELECT user_id,active_flag FROM user_master WHERE delete_flag = 0 AND user_id = ?`;

    var values1 = [user_id];

    connection.query(sql1, values1, async (err, information) => {
      if (err) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.internalServerError,
          data: {},
        });
      }

      if (information.length === 0) {
        return response.status(404).json({
          success: false,
          msg: languageMessages.msgUserNotFound,
          data: {},
        });
      }

      if (information[0].active_flag === 0) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.accountdeactivated,
          active_status: 0,
        });
      }
    });

    // cheak user end

    var sqlNotification =
      "SELECT notification_message_id FROM user_notification_message where other_user_id = ?  AND delete_flag = 0";

    connection.query(sqlNotification, [user_id], (err, result) => {
      if (err) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.internalServerError,
          key: "6",
        });
      } else {
        let delete_flag = 1;

        var sqlNotification =
          "UPDATE user_notification_message SET delete_flag = ? ,updatetime= now() WHERE  other_user_id = ? ";

        connection.query(
          sqlNotification,
          [delete_flag, user_id],
          (err, result) => {
            if (err) {
              return response.status(200).json({
                success: false,
                msg: languageMessages.internalServerError,
                key: "2",
              });
            } else {
              return response.status(200).json({
                success: true,
                msg: languageMessages.notificationDelete,
              });
            }
          }
        );
      }
    });
  } catch (error) {
    console.error("Error in try block:", error);

    return response
      .status(200)
      .json({ success: false, msg: languageMessages.internalServerError });
  }
};

// delete all notification end

async function oneSignalNotificationSend(
  title,
  message,
  jsonData,
  player_id_arr
) {
  try {
    const oneSignalAppId = "685007cb-c945-49d5-9d56-eba288e0f821";

    const oneSignalAuthorization =
      "YzhhYzNlNzQtZWQ5Mi00NzNmLWExNDgtMmVlZWYwMGJlNmMz";

    // console.log('player_id_arr',player_id_arr)

    const fields = {
      app_id: oneSignalAppId,

      contents: { en: message },

      headings: { en: title },

      include_player_ids: player_id_arr,

      data: { action_json: jsonData },

      ios_badgeType: "Increase",

      ios_badgeCount: 1,

      priority: 10,
    };

    const config = {
      headers: {
        "Content-Type": "application/json; charset=utf-8",

        Authorization: "Basic " + oneSignalAuthorization,
      },
    };

    const response = await axios.post(
      "https://onesignal.com/api/v1/notifications",
      fields,
      config
    );

    return response.data;
  } catch (error) {
    console.error("Error sending OneSignal notification:", error.message);

    return null;
  }
}

async function oneSignalNotificationSendCall(notification_arr) {
  console.log("notification_arr", notification_arr);

  if (notification_arr && notification_arr.length > 0) {
    for (const key of notification_arr) {
      const player_id_arr = [];

      if (key.player_id !== "") {
        player_id_arr.push(key.player_id);

        const title = key.title;

        const message = key.message;

        const action_json = key.action_json;

        await oneSignalNotificationSend(
          title,
          message,
          action_json,
          player_id_arr
        );
      }
    }
  } else {
    console.log("Notification array is empty. No notifications to send.");
  }
}

async function getUserPlayerId(user_id, callback) {
  try {
    if (!user_id) return "no";

    connection.query(
      "SELECT player_id FROM user_notification WHERE user_id = ?",
      [user_id],
      (err, result) => {
        if (err) {
          console.log("error : ", err);
        }

        if (result.length > 0) {
          let player_id = result[0].player_id;

          if (player_id === "123456") {
            player_id = "no";
          }

          //console.log('player_id',player_id)

          callback(player_id);
        } else {
          //console.log('player_id',player_id)

          // return 'no';

          callback("no");
        }
      }
    );
  } catch (error) {
    console.error("Error executing query:", error.message);

    return null;
  }
}

// get notification count start

const getNotificationCount = async (request, response) => {
  const { user_id } = request.query;

  try {
    if (!user_id) {
      return response.status(200).json({
        success: false,
        msg: languageMessages.msg_empty_param,
        key: "user_id",
      });
    }

    var sqlVal =
      "SELECT user_id,active_flag FROM user_master WHERE user_id = ? AND delete_flag = 0";

    await connection.query(sqlVal, [user_id], async (err, info) => {
      if (err) {
        return response
          .status(200)
          .json({ success: false, msg: languageMessages.internalServerError });
      }

      if (info.length <= 0) {
        return response
          .status(200)
          .json({ success: false, msg: languageMessages.msgUserNotFound });
      }

      if (info[0].active_flag === 0) {
        return response.status(200).json({
          success: false,
          msg: languageMessages.accountdeactivated,
          active_status: 0,
        });
      }

      // check notification count start

      const getCount =
        "SELECT count(notification_message_id) as count FROM user_notification_message WHERE delete_flag=0 and other_user_id=? and read_status = 0";

      await connection.query(
        getCount,
        [user_id],
        (getCountError, getCountResult) => {
          if (getCountError) {
            return response.status(200).json({
              success: false,
              msg: languageMessages.internalServerError,
              getCountError,
            });
          }

          let notificationCount = 0;

          if (getCountResult.length > 0) {
            notificationCount = getCountResult[0].count;
          }

          return response.status(200).json({
            success: true,
            msg: languageMessages.msgDataFound,
            notificationCount,
          });
        }
      );

      // check notification count end
    });
  } catch (error) {
    return response.status(200).json({
      success: false,
      msg: languageMessages.internalServerError,
      error,
    });
  }
};

// get notification count end

async function getUser(userId) {
  return new Promise((resolve, reject) => {
    const query1 =
      "SELECT  `user_id`, `login_type`, `login_type_first`, `user_type`, `email`, `password`, `username`, `f_name`, `l_name`, `name`, `dob`, `age`, `phone_code`, `mobile`, `otp`, `otp_verify`, `image`, `gender`, `address`, `latitude`, `longitude`, `zipcode`, `bio`, `bio_type`, `active_flag`, `approve_flag`, `profile_complete`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`, `notification_status`, `delete_flag`, `delete_reason`, `createtime`, `updatetime`, `mysqltime`, `signup_step`, `avatar_id`, `currect_location_permanent`, `about` FROM user_master WHERE user_id = ? and delete_flag=0";

    connection.query(query1, [userId], async (error, results) => {
      if (error) {
        reject(error);
        return;
      }

      if (results.length > 0) {
        const user = results[0];
        try {
          const userDataArray = {
            user_id: user.user_id,
            login_type: user.login_type,
            login_type_first: user.login_type_first,
            user_type: user.user_type,
            email: user.email,
            username: user.username,
            f_name: user.f_name,
            l_name: user.l_name,
            name: user.name,
            dob: user.dob,
            age: user.age,
            phone_code: user.phone_code,
            mobile: user.mobile,
            otp: user.otp,
            otp_verify: user.otp_verify,
            image: user.image,
            gender: user.gender,
            address: user.address,
            latitude: user.latitude,
            longitude: user.longitude,
            zipcode: user.zipcode,
            active_flag: user.active_flag,
            approve_flag: user.approve_flag,
            profile_complete: user.profile_complete,
            language_id: user.language_id,
            facebook_id: user.facebook_id,
            google_id: user.google_id,
            apple_id: user.apple_id,
            notification_status: user.notification_status,
            delete_reason: user.delete_reason,
            createtime: user.createtime,
            updatetime: user.updatetime,
            bio: user.bio,
            bio_type: user.bio_type,
            signup_step: user.signup_step,
            about: user.about,
          };
          resolve(userDataArray);
        } catch (err) {
          reject(err);
        }
      } else {
        resolve(null);
      }
    });
  });
}

// notification count start

function getNotificationCountOtherUser(user_id) {
  const getCount =
    "SELECT count(notification_message_id) as count FROM user_notification_message WHERE delete_flag=0 and other_user_id=? and read_status = 0";
  return new Promise((resolve, reject) => {
    connection.query(getCount, [user_id], (err, result) => {
      if (err) {
        return reject(err);
      } else {
        return resolve(result[0].count);
      }
    });
  });
}

// notification count end

module.exports = {
  getNotificationArrSingle,

  getNotification,

  deleteSingleNotification,

  deleteAllNotification,

  oneSignalNotificationSendCall,

  getNotificationCount,
  getNotificationCountOtherUser,
};
