const connection = require("../connection/dbconfig");

const { fetchUserData, DeviceTokenStore_1_Signal,getMyMusa,getSavedMusa, getsicialMyMusa,getSavedMusaNew,getMyMusaNew} = require("./function");
const {getFollowStatus1,displayStatus} = require('./musaController');
const languageMessages = require("./languageMessages");
// const timeAgo = require("./musaController")
const crypto = require('crypto');
const moment = require('moment');
const util = require('util');
const {mailer, contectusMailer,mailerWelcome,contectusReplyMailer} = require("./mailer")
const { getNotificationArrSingle, oneSignalNotificationSendCall } = require("./notification");
const { request, response } = require("express");
const signUp = async (request,response) =>{

    const {email,mobile,f_name,l_name,dob,password,device_type,player_id,user_type,login_type,social_id,zipcode} = request.body;

    try {

        if(!f_name){

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'f_name' });

        }

        if(!zipcode){

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'zipcode' });

        }

        if(!l_name){

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'l_name' });

        }

        if(!dob){

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'l_name' });

        }

        if (!email) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'email' });

        }

        if(!social_id){

            if (!password) {

                return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'password' });
    
            }
        }
       

        if (!device_type) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'device_type' });

        }

        if (!player_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'player_id' });

        }

        if (!user_type) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_type' });

        }

        if (!login_type) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'login_type' });

        }

    




        var google_id = null;

        var apple_id = null;

        var logintype1 = 0;

        if (login_type === 'google') {

            google_id = social_id;

            logintype1 = 1;

        } 

        if (login_type === 'apple') {

            apple_id = social_id;

            logintype1 = 2;

        }


        var sqlchekuser = "SELECT user_id, otp_verify,f_name,email FROM user_master WHERE email = ?  AND delete_flag = 0";

        connection.query(sqlchekuser,[email], async(err,info)=>{

            if (err) {
                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "5" });
            }
            var useremail = email;
            var fromName = f_name;
            var app_name= "MUSA APP";
            var message =  "Your MUSA  otp is : ";
            var subject =  "OTP Verification Code";
            var title = "Signup";
            const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";
            if(info.length > 0){
                useremail = info[0].email;
                fromName = info[0].f_name;
                app_name  =app_name;
                message = message;
                subject =subject;
            }
            else{
                useremail = email
                fromName = f_name;
                app_name  = app_name;
                message = message;
                subject = subject;
            }
          
            if(!social_id){
                await mailer(useremail, fromName,app_name,message,subject,title,app_logo).then(async data => {
                    if(data.status === 'yes'){
                        if (info.length > 0) {
                            var user_id = info[0].user_id;
            
                            if (info[0].otp_verify === 0) {
            
                                var sql1 = "UPDATE user_master SET otp = ?, updatetime = now(), login_type = ?,  google_id = ?, apple_id = ? WHERE user_id = ?";
            
                                connection.query(sql1, [data.otp, logintype1, google_id, apple_id, user_id],async (err, infomation) => {
            
                                    if (err) {
            
                                        console.error("Database error:", err);
            
                                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "1",error : err });
            
                                    } else {
            
            
            
                                        fetchUserData(user_id,async (error, userDataArray) => {
            
                                            if (error) {
            
                                                console.error('Error fetching user data:', error);
            
                                                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
            
                                            }
            
                                            return response.status(200).json({ success: true, msg: languageMessages.otpsend,userDataArray: userDataArray });
            
                                        });
            
                                    }
            
                                });
            
                            } else {
            
                                return response.status(200).json({ success: false, msg: languageMessages.accountAlreadyExists, key: "6" });
            
                            }
            
                        }
            
                        else{
            
                            const hashedPass = await hashPassword(password);
            
                            const insertUser = "INSERT INTO user_master(email,zipcode, mobile, f_name, l_name, dob, password, login_type_first, login_type,otp, user_type, google_id, apple_id, createtime, updatetime) VALUES (?, ?, ?, ?,?,?, ?, ?, ?, ?,? ,?,?,  now(), now())";
            
                            var values = [email,zipcode,mobile,f_name,l_name,dob, hashedPass,logintype1,logintype1,data.otp, user_type,google_id, apple_id];
            
                            connection.query(insertUser, values, (err, data) => {
            
                                if (err) {
            
                                    console.error("Database error:", err);
            
                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError,error : err  });
            
                                } else {
            
                                    const user_id = data.insertId;
            
                                    DeviceTokenStore_1_Signal(user_id, device_type, player_id, function(result) {
            
                                        console.error("Error storing device token:", result);
            
                                    });
                                    var plan_id = 1;
                                    var sqlplanInsert = "INSERT INTO user_plan_master(plan_id, user_id, createtime, updatetime) VALUES (?, ?,now(), now())";
                                    connection.query(sqlplanInsert,[plan_id,user_id],(err,result)=>{
                                        if (err) {
            
                                            console.error("Database error:", err);
                    
                                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError,error : err  });
                    
                                        }
                                       
                                        fetchUserData(user_id,async(error, userDataArray) => {
            
                                            if (error) {
                        
                                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
                    
                                            }

                             

                    
                                            return response.status(200).json({ success: true, msg: languageMessages.signupSuccessfully, userDataArray:userDataArray });
                    
                                        });
                                    })
            
                                }
            
                            });
            
                        }
                    }else{
                        return response.status(200).json({ success: true, msg: languageMessages.otpResendUnSuccess,data : data});
                    }
                    }).catch(err => {
                    console.error('Error:', err);
                });
            } else { 
                var otp_verify_status  = 1;
                var profile_complete_status = 1;
                const insertsql = "INSERT INTO user_master(email,zipcode, mobile, f_name, l_name, dob, login_type_first, login_type,user_type, google_id, apple_id,otp_verify ,profile_complete, createtime, updatetime) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ? ,?, ?, ? ,?,  now(), now())";
            
                var values = [email,zipcode,mobile,f_name,l_name,dob,logintype1,logintype1,user_type,google_id, apple_id,otp_verify_status,profile_complete_status ];

                connection.query(insertsql, values, (err, data) => {

                    if (err) {

                        console.error("Database error:", err);

                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError,error : err  });

                    } else {

                        const user_id = data.insertId;

                        DeviceTokenStore_1_Signal(user_id, device_type, player_id, function(result) {

                            console.error("Error storing device token:", result);

                        });
                        var plan_id = 1;
                        var sqlplanInsert = "INSERT INTO user_plan_master(plan_id, user_id, createtime, updatetime) VALUES (?, ?,now(), now())";
                        connection.query(sqlplanInsert,[plan_id,user_id],(err,result)=>{
                            if (err) {

                                console.error("Database error:", err);
        
                                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "1",error : err  });
        
                            }
                           
                            fetchUserData(user_id, async(error, userDataArray) => {

                                if (error) {
            
                                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
        
                                }

                                var useremail = email;
                                var fromName = f_name;
                                var app_name= "MUSA APP";
                                var message =  "Your MUSA otp is : ";
                                var subject =  "MUSA App Verification Code";
                                var title = "Signup";
                                const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";

                                // await mailer(useremail, fromName,app_name,message,subject,title,app_logo).then(async data => {
                                //     if(data.status === 'yes'){
                                //     }
                                // });
                                // send notification end
        
                                return response.status(200).json({ success: true, msg: languageMessages.signupSuccessfully, userDataArray:userDataArray });
        
                            });
                        })

                    }

                });
            }
           
        });

    } catch (error) {

       console.log(error); 
       return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

    }

}


// signup end



// resend otp start



const resendOtp = async (request, response) => {

    const { user_id } = request.body;

    console.log("user_id : ", user_id);

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_id' });

        }

        // user check exists or not 



        const query1 = "SELECT user_id,active_flag,email,f_name FROM user_master WHERE delete_flag=0 and user_id = ?";

        const values1 = [user_id];

        connection.query(query1,values1,async(queryError,queryResult)=>{

            if (queryError) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "1" });

            }

            if(queryResult.length <= 0){

                return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound});

            }

            if(queryResult[0].active_flag === 0 ){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status :0 });

            }

            const email = queryResult[0].email
            const fromName = queryResult[0].f_name;
            const app_name  = "MUSA APP";
            const message = "Your MUSA resend otp is : ";
            const Subject = "Resend OTP Verification Code";
            var title = "Resend otp"
            const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";
         


            await mailer(email, fromName,app_name,message,Subject,title,app_logo).then(data => {
                if(data.status === 'yes'){
                    var sql = 'UPDATE user_master SET otp = ?, updatetime = NOW() WHERE user_id = ? AND delete_flag = 0';
                    connection.query(sql, [data.otp, user_id], (error, result) => {
            
                        if (error) {
            
                            console.log(error, "error");
            
                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "2" });
            
                        } else {
            
                            fetchUserData(user_id, (error, userDataArray) => {
            
                                if (error) {
            
                                    console.error('Error fetching user data:', error);
            
                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
            
                                }
            
                                return response.status(200).json({ success: true, msg: languageMessages.otpResendSuccess,userDataArray });
            
                            })
                        }
            
                    });
                    // return response.status(200).json({ success: true, msg: languageMessages.otpResendSuccess,data :data});
                }else{
                    return response.status(200).json({ success: true, msg: languageMessages.otpResendUnSuccess});
                }
               
            }).catch(err => {
                console.error('Error:', err);
            });
        });

    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "3" });

    }

};



// reset otp end



// otp verify start



const otpVerify = (request, response) => {

    const { user_id, otp } = request.body;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_id' });

        }

        if (!otp) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'otp' });

        }



        // user check exists or not 



        const query1 = "SELECT user_id,active_flag FROM user_master WHERE delete_flag=0 and user_id = ?";

        const values1 = [user_id];

        connection.query(query1,values1,(queryError,queryResult)=>{

            if (queryError) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, queryError });

            }

            if(queryResult.length <= 0){

                return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound});

            }

            if(queryResult[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated ,active_status:0 });

            }

        });



        // user check exists or not 



        const checksql = "SELECT otp FROM user_master WHERE user_id = ? AND otp = ?";

        connection.query(checksql, [user_id, otp], (err, data) => {

            if (err) {

                console.error("Error executing SQL query:", err);

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            } else {

                if (data.length > 0) {

                    const updatesql = 'UPDATE user_master SET otp_verify = 1, profile_complete  = 1, updatetime = now() WHERE user_id = ?';

                    connection.query(updatesql, [user_id], (err, information) => {

                        if (err) {

                            console.error("Error updating user_master:", err);

                            return response.status(200).json({ success: false,msg: languageMessages.internalServerError });

                        } else {

                            fetchUserData(user_id, async(error, userDataArray) => {

                                if (error) {

                                    console.error('Error fetching user data:', error);

                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

                                }



                                    // send notification start 

                                    const user_id_notification = 1;

                                    const other_user_id_notification = user_id;

                                    const action = 'signup';

                                    const action_id = '0';

                                    const title = 'Signup';
                                    const messages = 'You are in! Welcome to MUSA App';

                                    const action_data = { user_id: user_id_notification, other_user_id: other_user_id_notification, action_id: action_id, action: action };

                                    getNotificationArrSingle(user_id_notification, other_user_id_notification, action, action_id, title, title, title, title, title, messages, messages, messages, messages, messages, action_data, async (notification_arr_check) => {
                                    let notification_arr_check_new = [notification_arr_check];

                                    if (notification_arr_check_new && notification_arr_check_new.length !== 0) {
                                       const notiSendStatus = await oneSignalNotificationSendCall(notification_arr_check_new);
                                    } else {
                                        console.log('Notification array is empty');
                                    }
                                });
                                // send notification end

                                var useremail = userDataArray.email;
                                var fromName = userDataArray.f_name;
                                var app_name= "MUSA APP";
                                var message =  "You are in! Welcome to MUSA App";
                                var subject =  "Welcome Mail";
                                var title1 = "Welcome";
                                const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";

                                await mailerWelcome(useremail, fromName,app_name,message,subject,title1,app_logo).then(async data => {
                                    if(data.status === 'yes'){
                                    }
                                });
                                // send notification end

                                return response.status(200).json({ success: true, msg: languageMessages.otpverifysuccess,userDataArray});

                            })

                        }

                    });

                } else {

                    return response.status(200).json({ success: false, msg: languageMessages.wrongotp });

                }

            }

        });

    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError});

    }

}



// otp verify end


// login start

const signIn  = (request,response) =>{

    const {email,password,player_id, device_type} = request.body;

    try {

        if(!email ) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'email'});

        }

        if (!password) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'password' });

        }

        if (!player_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'player_id' });

        }

        if (!device_type) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'device_type' });

        }





        var sqlLogin = "SELECT email,password,user_id FROM user_master WHERE email = ?  AND delete_flag = 0";

        connection.query(sqlLogin, [email] , async(err,info)=>{

            if (err) {

                console.error("Database error:", err);

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, key: "5" ,error :err});

            }

            if(info.length <= 0){

                return response.status(200).json({ success: false, msg: languageMessages.userNotRegisterHere });

            }

            if(info[0].active_flag === 0 ){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

            }

            if (info.length > 0) {

                var hashedPassword = await hashPassword(password);

                var user_id = info[0].user_id;

                const que1 = "SELECT user_id,password FROM user_master WHERE  email = ?  AND delete_flag = 0";

                const val1 = [email];

                connection.query(que1,val1,(que1Error,val1Result)=>{

                    if(que1Error){

                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:2,error : que1Error});

                    }

                    if(val1Result.length > 0){

                        if(hashedPassword !== val1Result[0].password){

                            // var pass = val1Result[0].password;

                            return response.status(200).json({ success: false, msg: languageMessages.PasswordNotCorrect});

                        } 

                    }

    

                    user_id = val1Result[0].user_id;

                    DeviceTokenStore_1_Signal(user_id, device_type, player_id, function(result) {

                    });

    

                    fetchUserData(user_id, (error, userDataArray) => {

                        if (error) {

                            console.error('Error fetching user data:', error);

                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:4,error : error});

                        }

                        return response.status(200).json({ success: true, msg: languageMessages.loginSuccessful, userDataArray:userDataArray });

                    })

                });

            }

        });

    } catch (error) {

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:2,error : error});

    }

}



// login end



// forget password send otp start



const forgetPassword = async (request,response) =>{

    const {email} = request.body;

    try {

        if (!email) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'email' });

        }

        // var otp = 123456;

        var sql = "SELECT user_id, user_type,email,f_name FROM user_master WHERE email = ? AND delete_flag = 0";

        connection.query(sql, [email], async(err, result) => {

            if (err) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            } else {

                if (result.length > 0) {


                const email = result[0].email
                const fromName = result[0].f_name;
                const app_name  = "MUSA APP";
                const message = "Forgot  password otp is : ";
                const subject = "Forgot  Password OTP Verification Code";
                var title = "Forgot  password ";
                const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";
                await mailer(email, fromName,app_name,message,subject,title,app_logo).then(data => {
                    if(data.status === 'yes'){
                        var user_type = result[0].user_type;
                        var user_id = result[0].user_id;
                        var otp = data.otp;
                        var sqlinsert = "INSERT INTO forgot_password_master(user_id, user_type, email, otp, createtime, updatetime) VALUES (?, ?, ?, ?, now(), now())";
    
                        connection.query(sqlinsert, [user_id, user_type, email, otp], (error, data) => {
    
                            if (error) {
    
                                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
    
                            }
    
                            fetchUserData(user_id, (error, userDataArray) => {
    
                                if (error) {
    
                                    console.error('Error fetching user data:', error);
    
                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:4});
    
                                }
    
                                return response.status(200).json({ success: true, msg: languageMessages.otpsend,userDataArray});
    
                            });
    
                        });
                    }else{
                        return response.status(200).json({ success: true, msg: languageMessages.otpResendUnSuccess});
                    }
                }).catch(err => {
                    console.error('Error:', err);
                });
        } else {

            return response.status(200).json({ success: false,  msg:languageMessages.msgUserNotFound });

         }

    }

    });

    } catch (error) {

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

    }

}



// forget password send otp end







// forgot pass resend otp start



const forgetResedOtpPassword = async (request, response) => {

    const { user_id } = request.body;



    if(!user_id){

        return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: "user_id" });

    }

    console.log("user_id : ", user_id);

    try {

        var sql = "select user_id,active_flag,email,f_name from user_master where user_id = ? and delete_flag=0";

        connection.query(sql,[user_id],async(err,info)=>{

            if(err){

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            }

            if(info.length <= 0 ){

                return response.status(200).json({ success: false,  msg:languageMessages.msgUserNotFound }); 

            }

            if(info[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 ,active : info[0].active_flag});

            }

            const email = info[0].email
            const fromName = info[0].f_name;
            const app_name  = "MUSA APP";
            const message = "Your Forgot  password resend otp is : ";
            const subject = "Forgot  Password Resend OTP Verification Code"
            var title = "Resend Forgot  password otp";
            const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";
            await mailer(email, fromName,app_name,message,subject,title,app_logo).then(data => {
                if(data.status === 'yes'){
                    var sql = 'UPDATE forgot_password_master SET otp = ?, updatetime = NOW() WHERE user_id = ? AND delete_flag = 0';

                    connection.query(sql, [data.otp, user_id], (error, result) => {
        
                        if (error) {
                
                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError});
        
                        } else {
        
                            fetchUserData(user_id, (error, userDataArray) => {
        
                                if (error) {
        
                                    console.error('Error fetching user data:', error);
        
                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError});
        
                                }
        
                             return response.status(200).json({ success: true, msg: languageMessages.otpsend,userDataArray,data : data.otp});
        
                        })
        
                    }
        
                });
                }else{
                    return response.status(200).json({ success: true, msg: languageMessages.otpResendUnSuccess});
                }
            }).catch(err => {
                console.error('Error:', err);
                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });
            });
        });
           
    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

    }

};



// forgot pass resend otp end





// forgot password otp verify start


const forgetPassOtpVerify = (request, response) => {

    const { user_id, otp } = request.body;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_id' });

        }

        if (!otp) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'otp' });

        }



        // Check user

        var sql = "select user_id,active_flag from user_master where user_id = ? and delete_flag=0";

        connection.query(sql,[user_id],(err,info)=>{

            if(err){

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError,error : err });

            }

            if(info.length <= 0 ){

                return response.status(200).json({ success: false,  msg:languageMessages.msgUserNotFound }); 

            }

            if(info[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

            }



            // Check OTP

            const checksqlOtp = "SELECT otp FROM forgot_password_master WHERE user_id = ? AND otp = ?";

            connection.query(checksqlOtp, [user_id, otp], (err, data) => {

                if (err) {

                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error : err });

                } else {

                    if (data.length > 0) {

                        let otp_verified = 1;

                        const updatesql = 'UPDATE forgot_password_master SET otp_verified = ?, updatetime = NOW() WHERE user_id = ?';

                        connection.query(updatesql, [otp_verified,user_id], (err, information) => {

                            if (err) {

                                console.error("Error updating user_master:", err);

                                return response.status(200).json({ success: false,msg: languageMessages.internalServerError });

                            } else {

                                fetchUserData(user_id, (error, userDataArray) => {

                                    if (error) {

                                        console.error('Error fetching user data:', error);

                                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error : error});

                                    }

                                    return response.status(200).json({ success: true, msg: languageMessages.otpverifysuccess,userDataArray});

                                })

                            }

                        });

                    } else {

                        return response.status(200).json({ success: false, msg: languageMessages.wrongotpsend});

                    }

                }

            });

        });

    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error : error});

    }

}





// forgot password otp verify end







// change password start 





const updateNewPassword = (request, response) => {

    const { user_id, password } = request.body;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_id' });

        }

        if (!password) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'password' });

        }

        var sql = "SELECT user_id,active_flag FROM user_master WHERE user_id = ? and delete_flag=0";

        connection.query(sql, [user_id], async (err, info) => {

            if (err) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            }

            if (info.length <= 0) {

                return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound });

            }

            if(info[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated ,active_status : 0});

            }

           

            const hashedPassword = await hashPassword(password);

            console.log(hashedPassword);

        

            var updateSql = 'UPDATE user_master SET password=?, updatetime = NOW() WHERE user_id = ? AND delete_flag = 0';

            connection.query(updateSql, [hashedPassword, user_id], (err, result) => {

            if (err) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            }

            if (result.affectedRows > 0) {

                fetchUserData(user_id, (error, userDataArray) => {

                if (error) {

                    console.error('Error fetching user data:', error);

                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:4});

                }

                return response.status(200).json({ success: true, msg: languageMessages.forgotNewpasswordUpdate,userDataArray});

            })

                           

            } else {

                return response.status(404).json({ success: false, msg: languageMessages.msgUserNotFound });

                }

            });  

        });

    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

    }

}



// change password end





// change password start



const changePassword = (request,response)=>{

    const {user_id,old_password,new_password} = request.body;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'user_id' });

        }

        if (!old_password) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'old_password' });

        }

        if (!new_password) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param,key:'new_password' });

        }

        

        var sql = "SELECT user_id,active_flag FROM user_master WHERE user_id = ? and delete_flag=0";

        connection.query(sql, [user_id], async (err, info) => {

            if (err) {

                return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

            }

            if (info.length <= 0) {

                return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound });

            }

            if(info[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated ,active_status : 0});

            }



            var sqlforget = "select password from user_master where user_id = ?";

            connection.query(sqlforget,[user_id],async(err,data)=>{

                if(err){

                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError });  

                }else{

                    if(data.length <= 0){

                        return response.status(200).json({ success: false, msg: languageMessages.msgDataNotFound }); 

                    }

                    var password = data[0].password;

                    const old_password_hash = await hashPassword(old_password);

                    if(password===old_password_hash){

                        const new_pass = await hashPassword(new_password);

                     

                        var updateSql = 'UPDATE user_master SET password=?, updatetime = NOW() WHERE user_id = ? AND delete_flag = 0';

                        connection.query(updateSql, [new_pass, user_id], (err, result) => {

                           if (err) {

                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

                          }

                        if (result.affectedRows > 0) {

                            fetchUserData(user_id, (error, userDataArray) => {

                                if (error) {

                                    console.error('Error fetching user data:', error);

                                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError,key:4});

                                }

                                return response.status(200).json({ success: true, msg: languageMessages.forgotNewpasswordUpdate,userDataArray});

                            })

                          

                        } else {

                            return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound });

                        }

                    });

                    }else{

                        return response.status(200).json({ success: false, msg:languageMessages.newOldPassword });  

                    }

                }

            })

        });

    } catch (error) {

        console.error("Error:", error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

    }

}


// change assword end


const contectUs = async(request,response) =>{

    const { name,email,description , user_id} = request.body;

    try {

        // if(!user_id){

        //     return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        // }

        if(!name){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "name"});

        }

        if(!email){

            return response.status(200).status({success : false, msg : languageMessages.msg_empty_param, key : "email"});

        }

        if(!description){

            return response.status(200).status({success : false, msg : languageMessages.msg_empty_param, key : "description"});

        }

        // cheak user start


        const userQuery1 = "SELECT user_id, f_name,email FROM user_master where user_id = 1 and delete_flag = 0";

        const adminResult = await new Promise((resolve, reject) => {

            connection.query(userQuery1, (err, result) => {

                if (err) reject(err);

                else resolve(result);

            });

        });


        let user_type = "";
        // let email = "";
        // const userQuery = "SELECT user_id, active_flag user_type,f_name,email FROM user_master where user_id = ? and delete_flag = 0";

        // const userResult = await new Promise((resolve, reject) => {

        //     connection.query(userQuery, [user_id], (err, result) => {

        //         if (err) reject(err);

        //         else resolve(result);

        //     });

        // });






        // if (userResult.length === 0) {

        //     return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound });

        // }

        // if (userResult[0].active_flag === 0) {

        //     return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });

        // }

        // user_type = userResult[0].user_type;
        // if(user_type==1){
            user_type_name = "User"
        // }
        // email = userResult[0].email;
        const admin_name = adminResult[0].f_name;
        const email1 = adminResult[0].email;
        const useremail = email;
        const fromName = name;
        const app_name  = "MUSA APP";
        const message = description;
        const app_logo = "https://meribhiapp.com/2024/musaapp/server/webservice/imagelogo/logo.png";
        var title = "Contact us";

        await contectusReplyMailer(admin_name,user_type_name,email1, fromName,app_name,message,title,useremail,app_logo);
        await contectusMailer(admin_name,user_type_name,email1, fromName,app_name,message,title,useremail,app_logo).then(data => {
            if(data === 'yes'){
                const sqlcontect = "INSERT INTO contact_us_master (user_id, name, email, message,user_type, createtime, updatetime) VALUES (?, ?, ?, ?, ?, NOW(), NOW())";

                connection.query(sqlcontect, [user_id, name, email, description, user_type], (err, result) => {
        
                    if (err) {
        
                        console.error("Error inserting contact information:", err);
        
                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: err ,line:'1444',data:data});
        
                    }
                    
        
                    return response.status(200).json({ success: true, msg: languageMessages.contactUsMsg,data:data});
        
                });
            }else{
                return response.status(200).json({ success: false, msg: languageMessages.otpResendUnSuccess,line:'1452',data:data});
            }
        }).catch(err => {
            console.error('Error:', err);
            return response.status(200).json({ success: false, msg: languageMessages.otpResendUnSuccess,err:err,line:'1456'});
        });
        


        // const sqlcontect = "INSERT INTO contact_us_master (user_id, name, email, message,user_type, createtime, updatetime) VALUES (?, ?, ?, ?, ?, NOW(), NOW())";

        // connection.query(sqlcontect, [user_id, name, email, description, user_type], (err, result) => {

        //     if (err) {

        //         console.error("Error inserting contact information:", err);

        //         return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: err });

        //     }

        //     return response.status(200).json({ success: true, msg: languageMessages.contactUsMsg });

        // });

    } catch (error) {

        return response.status(200).json({success : false , msg : languageMessages.internalServerError, error : error.message});

    }

}



// hash pass start





// update profile start

const updateProfile = (request,response) =>{

    // const {name,mobile,email,user_id} = request.body;

    const {user_id,f_name,l_name,email,mobile,zip_code,dob,bio,image,zipcode} = request.body;

    try {

        if(!user_id){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        }

        if(!f_name){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "f_name"});

        }

        if(!l_name){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "l_name"})

        }

        if(!email){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "email"});

        }

        // if(!email){

        //     return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "email"});

        // }

        // if(!mobile){

        //     return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "mobile"})

        // }

        if(!zipcode){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "zipcode"});

        }

        if(!dob){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "dob"})

        }

        // if(!bio){

        //     return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "bio"});

        // }





        // cheak user start 

        var sqlcheak = "SELECT user_id,active_flag,user_type,image,bio FROM user_master where user_id = ? and delete_flag = 0";

        connection.query(sqlcheak,[user_id],(err,result) =>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(result.length <= 0){

                return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

            }

            if(result[0].active_flag === 0){

                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

            }
            var user_image =  (image) ? image : result[0].image;
            var bio1 = (bio) ? bio : result[0].bio;

        var sqlupdate = "UPDATE user_master set f_name = ? ,l_name = ? ,email = ? ,mobile = ? ,zipcode = ? ,dob = ? ,bio= ?, image = ?   where user_id= ? AND delete_flag = 0";

        connection.query(sqlupdate,[f_name,l_name,email,mobile,zipcode,dob,bio1,user_image,user_id],(err,result) =>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(result.affectedRows > 0){
                
                fetchUserData(user_id,async (error, userDataArray) => {
        
                    if (error) {

                        console.error('Error fetching user data:', error);

                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

                    }
                    return response.status(200).json({success : true,msg : languageMessages.profileUpdateSuccessfully,userDataArray: userDataArray});
                    // return response.status(200).json({ success: true, msg: languageMessages.otpsend,userDataArray: userDataArray });

                });


            }

        })
    });
  

    } catch (error) {

        return response.status(200).json({success : false , msg : languageMessages.internalServerError, error : error});

    }
        //   });

}

// update profile end





// update profile image start

const updateProfileImage = (request,response) =>{

    const {user_id,image} = request.body;

    // var image = request.files["image"];

    try {

        if(!user_id){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        }

        if(!image){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "image"});

        }

        // cheak user start 

            var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

            connection.query(sqlcheak,[user_id],(err,result) =>{

            if(err){

               return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(result.length <= 0){

               return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

            }

             if(result[0].active_flag === 0){

              return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

            }

        });

        var updateimage = "UPDATE user_master set image = ? where user_id = ? AND delete_flag = 0";

        connection.query(updateimage,[image,user_id],(err,data)=>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(data.affectedRows > 0){

                return response.status(200).json({success : true,msg : languageMessages.profileImageUpdate});

            }

        })



    } catch (error) {

        return response.status(200).json({success : false , msg : languageMessages.internalServerError, error : error});

 

    }

}



// update profile image end



async function hashPassword(pass) {

    return crypto.createHash('sha256').update(pass).digest('hex');

}



// delete account start

const deleteAccount  = async (request,response) =>{

    const{user_id,reason} = request.body;

    try {

        if(!user_id){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        }

        if(!reason){

            return response.status(200).json({success : false , msg : languageMessages.msg_empty_param , key : "reason"});

        }

         // cheak user start 

        var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

        await connection.query(sqlcheak,[user_id],async(err,result) =>{

        if(err){

            return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

        }

        if(result.length <= 0){

            return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

        }

        if(result[0].active_flag === 0){

           return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

        }

        var delete_flag= 1;

        let updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
        var updateimage = "UPDATE user_master set delete_reason = ?,delete_flag = ?,updatetime=? where user_id = ? AND delete_flag = 0";

        await connection.query(updateimage,[reason,delete_flag,updatetime,user_id],async(err,data)=>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(data.affectedRows > 0){

                await connection.query("UPDATE musa_master SET delete_flag=1,updatetime=? WHERE user_id=? and delete_flag=0",[updatetime,user_id],async(musaErr,musaResult)=>{});

                await connection.query("UPDATE comment_master SET delete_flag=1,updatetime=? WHERE user_id=? and delete_flag=0",[updatetime,user_id],async(cmtErr,cmtResult)=>{});
                await connection.query("UPDATE contributor_follow_master SET delete_flag=1,updatetime=? WHERE user_id=? and delete_flag=0",[updatetime,user_id],async(conErr,conResult)=>{});
                await connection.query("UPDATE contributor_follow_master SET delete_flag=1,updatetime=? WHERE other_user_id=? and delete_flag=0",[updatetime,user_id],async(contErr,contResult)=>{});

                return response.status(200).json({success : true,msg : languageMessages.deleteAccountsuccessfully});

            }

        })



     });

    } catch (error) {

        return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

    }

}



// delete account end 

// get plan start

const getAllPlan = (request,response) =>{
    // const {user_id} = request.query;

    // try {
        
    //     if(!user_id){

    //         return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

    //     }
    //     // cheak user start 

    //         var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

    //         connection.query(sqlcheak,[user_id],(err,result) =>{

    //         if(err){

    //             return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

    //         }

    //         if(result.length <= 0){

    //            return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

    //         }

    //         if(result[0].active_flag === 0){

    //            return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

    //         }
            // var sqlplanData = "SELECT `plan_id`, `type`, `gb`, `amount`, `description` FROM `plan_master` WHERE delete_flag = 0";

            // connection.query(sqlplanData, async (err,result) =>{

            // if(err){

            //     return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            // }

            // if(result.length <= 0){

            //    return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

            // }
            // var plan_data = [];

            // if(result.length >0){

            //     for(var data of result){

            //         var plan_purchase_status = await getplanstatus(data.plan_id,user_id);

            //         if(plan_purchase_status == 0){

            //             plan_data.push({

            //                 plan_id : data.plan_id,
            //                 type : data.type,
            //                 gb : data.gb,
            //                 amount : data.amount,
            //                 description : data.description,
            //                 // plan_purchase_status : plan_purchase_status,
            //                 // plan_purchase_status_lable : "0 for No, 2 for yes",
            //                 status : false

            //             })

            //         } 

            //     }
                
            // }
            // if(plan_data.length <=0){

            //     plan_data ="NA"

            // }

            //  return response.status(200).json({ success: true, msg: languageMessages.msgDataFound,plan_data : plan_data});

            // });

        // });

    // } catch (error) {
    //     return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err.message});
    // }

    const { user_id } = request.query;

    try {
        if (!user_id) {
            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: "user_id" });
        }

        // Check user start
        const sqlCheck = "SELECT user_id, active_flag FROM user_master WHERE user_id = ? AND delete_flag = 0";

        connection.query(sqlCheck, [user_id], (err, result) => {
            if (err) {
                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: err });
            }

            if (result.length <= 0) {
                return response.status(200).json({ success: false, msg: languageMessages.msgDataNotFound });
            }

            if (result[0].active_flag === 0) {
                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });
            }

            if (result.length > 0) {
                const sqlGetPlans = "SELECT group_concat(plan_id SEPARATOR ',') AS plan_ids FROM user_plan_master WHERE user_id = ?";
                
                connection.query(sqlGetPlans, [user_id], (err, data) => {
                    if (err) {
                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: err });
                    }
                    var plan_data = [];
                    if (data.length > 0 && data[0].plan_ids) {
                        const planIds = data[0].plan_ids;

                        const sqlPlanData = `SELECT plan_id, type, gb, amount, description  FROM plan_master  WHERE plan_id NOT IN (${planIds}) AND delete_flag = 0`;

                        connection.query(sqlPlanData, (err, planData) => {
                            if (err) {
                                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: err });
                            }
                            for(var data of planData) {
                                plan_data.push({
                                    plan_id : data.plan_id,
                                    type : data.type,
                                    gb : data.gb,
                                    amount : data.amount,
                                    description : data.description,
                                    status : false
                                });
                            }
                            
                            if(plan_data.length <=0){
                                plan_data = "NA"
                            }
                            return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, plan_data: plan_data });
                        });
                    } else {
                        if(plan_data.length <=0){
                            plan_data = "NA"
                        }
                        return response.status(200).json({ success: true, msg: languageMessages.msgDataFound,plan_data: plan_data });
                    }
                });
            }
        });
    } catch (error) {
        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: error.message });
    }
}

// get plan end 


async function getplanstatus(plan_id,user_id){
    var sqlstatus = "SELECT user_id from user_plan_master where user_id = ? AND plan_id = ? AND delete_flag = 0";
    return new Promise((resolve, reject) => {
        connection.query(sqlstatus, [user_id,plan_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                if(result.length > 0)
                  resolve(1);
                else
                  resolve(0);
            }
        });
    });
}


// get plan history start

const getPlanHistory = (request,response) =>{
    const {user_id} = request.query;

    try {
        
        if(!user_id){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        }
        // cheak user start 

            var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

            connection.query(sqlcheak,[user_id],(err,result) =>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(result.length <= 0){

               return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

            }

            if(result[0].active_flag === 0){

               return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

            }
            var sqlHistory = "SELECT `user_plan_id`, `plan_id`, `user_id` ,`transaction_id`,status, `createtime` FROM `user_plan_master` WHERE  delete_flag = 0 AND user_id = ? order by user_plan_id desc";

            connection.query(sqlHistory,[user_id], async(err,result) =>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(result.length <= 0){

               return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

            }


            var hisoryData = [];
            for(var data of result){

            const timestamp =data.createtime;
            const date = new Date(timestamp);

            const options = { year: 'numeric', month: 'short', day: '2-digit' };
            const formattedDate = date.toLocaleDateString('en-US', options);

            var planData = await getPlanData1(data.plan_id);
            hisoryData.push({
                user_plan_id : data.user_plan_id,
                plan_id : data.plan_id,
               
                user_id : data.user_id,
                type : (planData) ? planData[0].type : "NA",
                type_lable : "0 for free , 1 for premium",
                amount : (planData) ?   planData[0].amount : "NA",
                gb : (planData) ?   planData[0].gb : "NA",
                description : (planData) ? planData[0].description : "NA",
                createtime : formattedDate,
                transaction_id : data.transaction_id,
                status : data.status,
                status_lable : "1=active,2=expired"
                });
            }
            if(hisoryData.length <=0 ){
                hisoryData = "NA"
            }
          
            return response.status(200).json({ success: true, msg: languageMessages.msgDataFound,plan_data : hisoryData });


            });

        });

    } catch (error) {
        return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err.message});
    }
}

// get plan hisory end 

async function getPlanData1(plan_id){
    return new Promise((resolve, reject) => {

        const query1 = "SELECT `plan_id`, `type`, `gb`, `amount`, `description` FROM `plan_master` WHERE delete_flag = 0 AND plan_id = ?";

        connection.query(query1, [plan_id], (error, results) => {

            if (error) {

                reject(`Error fetching like status: ${error.message}`);

                return;

            }



            if (results.length > 0) {

                resolve(results);

            } else {

                resolve("NA");

            }

        });

    });
}




// about yourself start

const aboutYourSelf = (request,response) =>{

    const {user_id,bio,bio_type} = request.body; 

    try {

        if(!user_id){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "user_id"})

        }

        if(!bio ){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "bio"})

        }

        if(!bio_type ){

            return response.status(200).json({success : false,msg : languageMessages.msg_empty_param, key : "bio_type"})

        }

     // cheak user start 

          var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

          connection.query(sqlcheak,[user_id],(err,result) =>{

          if(err){

              return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

          }

          if(result.length <= 0){

              return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

          }

          if(result[0].active_flag === 0){

             return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

          }

        });



        var updateimage = "UPDATE user_master set bio = ?, bio_type = ? where user_id = ? AND delete_flag = 0";

        connection.query(updateimage,[bio,bio_type,user_id],(err,data)=>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(data.affectedRows > 0){
            

                fetchUserData(user_id,async (error, userDataArray) => {

                    if (error) {

                        console.error('Error fetching user data:', error);

                        return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

                    }
                    return response.status(200).json({success : true,msg : languageMessages.bioaddsuccessfully,userDataArray});
                });

                

            }

        })



    } catch (error) {

        

    }

}



// about yoursef end





// get profile details start



const getProfileDetails = async (request, response) => {

    const { user_id,offset} = request.query;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'user_id' });

        }



        const sqlcheak = "SELECT user_id, active_flag FROM user_master WHERE user_id = ? AND delete_flag = 0";

        const result = await new Promise((resolve, reject) => {

            connection.query(sqlcheak, [user_id], (err, result) => {

                if (err) reject(err);

                else resolve(result);

            });

        });



        if (result.length <= 0) {

            return response.status(200).json({ success: false, msg: languageMessages.msgDataNotFound });

        }



        if (result[0].active_flag === 0) {

            return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });

        }



        const userData = await getUser(user_id);

        const display_request_count = await displayRequestCount1(user_id);
      let limit = 5;
        // const mymusaData = await getMyMusaNew(user_id,limit,offset, response);
        const mymusaData = await getMyMusa(user_id, response);

        const savedMusa = await getSavedMusaNew(user_id,response);

        const mycontributorcount = await getmyComtributorCount(user_id);

        const contributor = await getContributor(user_id);

        const myMusa = await getmyMusaCount(user_id);

       const img_video = await getMyAllMusaImage(user_id);
       const img_video_new = await getMyMusavideoNew(user_id);

        var profile_data = {

            display_request_count : display_request_count,
            name :(userData) ?  userData.name : "NA",

            f_name :(userData) ? userData.f_name : "NA",

            l_name :(userData) ? userData.l_name : "NA",

            image : (userData) ? userData.image : "NA",

            bio :(userData) ? userData.bio : "NA",

            age :(userData) ? userData.age : "NA",

            email :(userData) ? userData.email : "NA",

            img_video:img_video.length > 0 ? img_video : 'NA',
            img_video_new:img_video_new.length > 0 ? img_video_new : 'NA',
            mycontributorcount:mycontributorcount,

            ContributorCount : contributor,

            myMusaCount : myMusa,

            mymusaData : mymusaData,

            savedMusa : savedMusa,
           
        }

        let loadmore = false;
        if(mymusaData != 'NA'){
            loadmore = mymusaData.length >= limit ? true : false ;
        }
        
        return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: profile_data,loadmore:loadmore});

    } catch (error) {

        console.error(error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: error.message });

    }

}



// get profile details en





// check myComtributor count start

function getmyComtributorCount(user_id) {

    return new Promise((resolve, reject) => {

        const query = "SELECT count(cfm.contributor_id) as contributor_count FROM contributor_follow_master as cfm , user_master as um WHERE cfm.user_id = ? AND cfm.delete_flag = 0 and um.user_id=cfm.other_user_id and um.delete_flag=0";

        connection.query(query, [user_id], (error, results) => {

            if (error) {

                reject(`Error fetching like status: ${error.message}`);

                return;

            }



            if (results.length > 0) {

                resolve(results[0].contributor_count);

            } else {

                resolve(0);

            }

        });

    });

}

// check myComtributor count end





// check Comtributor count start

function getContributor(user_id) {

    return new Promise((resolve, reject) => {

        const query = "SELECT count(contributor_id) as contributor_count FROM contributor_follow_master WHERE other_user_id = ? AND delete_flag = 0";

        connection.query(query, [user_id], (error, results) => {

            if (error) {

                reject(`Error fetching like status : ${error.message}`);

                return;

            }



            if (results.length > 0) {

                resolve(results[0].contributor_count);

            } else {

                resolve(0);

            }

        });

    });

}

// check Comtributor count end



// check musa count start

function getmyMusaCount(user_id) {

    return new Promise((resolve, reject) => {

        const query = "SELECT count(musa_id) as musa_count FROM musa_master WHERE user_id = ? AND delete_flag = 0";

        connection.query(query, [user_id], (error, results) => {

            if (error) {

                reject(`Error fetching like status: ${error.message}`);

                return;

            }



            if (results.length > 0) {

                resolve(results[0].musa_count);

            } else {

                resolve(0);

            }

        });

    });

}

// check musa count end


async function getUser(userId) {
    return new Promise((resolve, reject) => {
      const query1 = "SELECT  `user_id`, `login_type`, `login_type_first`, `user_type`, `email`, `password`, `username`, `f_name`, `l_name`, `name`, `dob`, `age`, `phone_code`, `mobile`, `otp`, `otp_verify`, `image`, `gender`, `address`, `latitude`, `longitude`, `zipcode`, `bio`, `bio_type`, `active_flag`, `approve_flag`, `profile_complete`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`, `notification_status`, `delete_flag`, `delete_reason`, `createtime`, `updatetime`, `mysqltime`, `signup_step`, `avatar_id`, `currect_location_permanent`, `about` FROM user_master WHERE user_id = ? and delete_flag=0";
  
      connection.query(query1, [userId], async (error, results) => {
        if (error) {
          reject(error);
          return;
        }
  
        if (results.length > 0) {
          const user = results[0];  
          try {
            const userDataArray = {
              user_id: user.user_id,
              login_type: user.login_type,
              login_type_first: user.login_type_first,
              user_type: user.user_type,
              email: user.email,
              username : user.username,
              f_name: user.f_name,
              l_name: user.l_name,
              name: user.name,
              dob: user.dob,
              age: user.age,
              phone_code: user.phone_code,
              mobile: user.mobile,
              otp: user.otp,
              otp_verify: user.otp_verify,
              image: user.image,
              gender: user.gender,
              address: user.address,
              latitude: user.latitude,
              longitude: user.longitude,
              zipcode : user.zipcode,
              active_flag: user.active_flag,
              approve_flag: user.approve_flag,
              profile_complete: user.profile_complete,
              language_id: user.language_id,
              facebook_id: user.facebook_id,
              google_id: user.google_id,
              apple_id: user.apple_id,
              notification_status: user.notification_status,
              delete_reason: user.delete_reason,
              createtime: user.createtime,
              updatetime: user.updatetime,
              bio: user.bio,
              bio_type : user.bio_type,
              signup_step: user.signup_step,
              about : user.about,
            };
            resolve(userDataArray);
          } catch (err) {
            reject(err);
          }
        } else {
          resolve(null);
        }
      });
    });
}

const purchasePlan = (request,response) =>{
    const {user_id,plan_id,transaction_id} = request.body;
    try {
        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'user_id' });

        }
        if (!plan_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'plan_id' });

        }
        if (!transaction_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'transaction_id' });

        }

         // cheak user start 

        var sqlcheak = "SELECT user_id,active_flag FROM user_master where user_id = ? and delete_flag = 0";

        connection.query(sqlcheak,[user_id],(err,result) =>{

        if(err){

            return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

        }

        if(result.length <= 0){

            return response.status(200).json({success : false ,msg: languageMessages.msgDataNotFound})

        }

        if(result[0].active_flag === 0){

            return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });

        }
        

        var updateimage = "UPDATE user_plan_master set status = 2 where user_id = ? AND delete_flag = 0";

        connection.query(updateimage,[user_id],async(err,data)=>{

            if(err){

                return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});

            }

            if(data.affectedRows > 0){

                let amount = 0;
                await connection.query("SELECT amount FROM plan_master WHERE plan_id=?",[plan_id],(planErr,planResult)=>{
                    amount = planResult[0].amount;

                var insertSql = "INSERT INTO user_plan_master(user_id,plan_id,transaction_id,createtime, updatetime,amount) VALUES (?, ?, ?, now(), now(),?) "
                connection.query(insertSql,[user_id,plan_id,transaction_id,amount],(err,data)=>{
                    if(err){

                        return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err});
        
                    } 


                    fetchUserData(user_id,async (error, userDataArray) => {
        
                        if (error) {

                            console.error('Error fetching user data:', error);

                            return response.status(200).json({ success: false, msg: languageMessages.internalServerError });

                        }
                        return response.status(200).json({success : true, msg : languageMessages.planuPurchasesuccessfully,userDataArray: userDataArray});
                        // return response.status(200).json({ success: true, msg: languageMessages.otpsend,userDataArray: userDataArray });

                    });
                });
                });

            }
        })
       });
    } catch (error) {
        return response.status(200).json({success : false,msg : languageMessages.internalServerError, error : err.message});
    }
}




const getOtherUserProfileDetails = async(request,response) =>{

    const {user_id,other_user_id} = request.query;

    try {

        if (!user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'user_id' });

        }

        if (!other_user_id) {

            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: 'other_user_id' });

        }



        const sqlcheak = "SELECT user_id, active_flag FROM user_master WHERE user_id = ? AND delete_flag = 0";

        const result = await new Promise((resolve, reject) => {

            connection.query(sqlcheak, [user_id], (err, result) => {

                if (err) reject(err);

                else resolve(result);

            });

        });



        if (result.length <= 0) {

            return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound });

        }



        if (result[0].active_flag === 0) {

            return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });

        }



        const userData = await getUser(other_user_id);

        const mymusaData = await getsicialMyMusa(other_user_id,user_id, response);

        // const savedMusa = await getSavedMusa(other_user_id);

        const mycontributorcount = await getmyComtributorCount(other_user_id);

        const contributor = await getContributor(other_user_id);

        const follow_staus = await getFollowStatus1(user_id,other_user_id);

        const myMusa = await getmyMusaCount(other_user_id);

        var profile_data = {

            name :(userData) ?  userData.name : "NA",

            f_name :(userData) ? userData.f_name : "NA",

            l_name :(userData) ? userData.l_name : "NA",

            image : (userData) ? userData.image : "NA",

            bio :(userData) ? userData.bio : "NA",

            age :(userData) ? userData.age : "NA",

            email :(userData) ? userData.email : "NA",

            mycontributorcount:mycontributorcount,

            ContributorCount : contributor,

            myMusaCount : myMusa,

            mymusaData : mymusaData,
            follow_staus : follow_staus,
            follow_staus_text: "0 = no , 1 = yes ",
status : false
            // savedMusa : savedMusa,

        

        }

        return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, profile_data: profile_data });

    } catch (error) {

        console.error(error);

        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error: error.message });

    }
}


// all my musa images start

// async function getMyAllMusaImage(user_id) {
//     const sqlSelect = "SELECT mim.musa_image_id, mim.image_audio, mim.thumbnail_image, mim.musa_id, mim.user_id, mim.type, mim.image_audio_type, mim.size_flag FROM musa_image_master as mim , musa_master as mm WHERE mim.user_id = ? and mim.image_audio_type=1 and mim.delete_flag=0 and mim.musa_id=mm.musa_id and mm.delete_flag=0";
//     return new Promise((resolve, reject) => {
//         connection.query(sqlSelect, [user_id], (err, result) => {
//             if (err) {
//                 reject(err);
//             } else {
//                 let videos = [];
//                 let images = [];
//                 let largeImages = [];
              
//                 const increments = [1, 1, 5];
// let current_value = 17;
// let normalPlacementIndexes = [3, 4, 5, 10, 11, 12, 13, 17];

// while (current_value < 1000) {
// for (let increment of increments) {
// current_value += increment;
// if (current_value > 1000) {
// break;
// }
// normalPlacementIndexes.push(current_value);
// }
// }

// console.log(normalPlacementIndexes);

//                 let videoPlacementIndexes = [1, 2, 8, 9, 15, 16, 22, 23, 29, 30, 36, 37, 43, 44, 50, 51, 57, 58, 64, 65, 71, 72, 78, 79, 85, 86, 92, 93, 99, 100, 106, 107, 113, 114, 120, 121, 127, 128, 134, 135, 141, 142, 148, 149, 155, 156, 162, 163, 169, 170, 176, 177, 183, 184, 190, 191, 197, 198, 204, 205, 211, 212, 218, 219, 225, 226, 232,233,239,240,246,247,253,254,260,261,267,268,274,275,281,282,288,289,295,296,302,303,309,310,316,317,323,324,330,331,337,343,344,350,351,357,358,364,365,371,372,378,379,385,386,392,393,399,400,406,407,413];


//                 let largeImagePlacementIndexes = [0, 6, 7, 14];
// const increments1 = [6, 1];
// let current_value2 = 14;

// while (current_value2 < 1000) {
// for (let increments of increments1) {
// current_value2 += increments;
// if (current_value2 > 1000) {
// break;
// }
// largeImagePlacementIndexes.push(current_value2);
// }
// }

// console.log(largeImagePlacementIndexes);

//                 // Separate videos, images, and large images based on type and size_flag
//                 for (const row of result) {
//                     if (row.image_audio_type === 3) { // Video
//                         videos.push({
//                             musa_image_id: row.musa_image_id,
//                             size_flag: row.size_flag,
//                             size_flag_text: '0=normal,1=lengthy',
//                             image_audio_type: row.image_audio_type,
//                             image_audio_type_text: '1=image,3=video',
//                             image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                             thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
//                         });
//                     } else if (row.image_audio_type === 1) { // Image
//                         if (row.size_flag === 1) {
//                             largeImages.push({
//                                 musa_image_id: row.musa_image_id,
//                                 size_flag: row.size_flag,
//                                 size_flag_text: '0=normal,1=lengthy',
//                                 image_audio_type: row.image_audio_type,
//                                 image_audio_type_text: '1=image,3=video',
//                                 image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                                 thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
//                             });
//                         } else {
//                             images.push({
//                                 musa_image_id: row.musa_image_id,
//                                 size_flag: row.size_flag,
//                                 size_flag_text: '0=normal,1=lengthy',
//                                 image_audio_type: row.image_audio_type,
//                                 image_audio_type_text: '1=image,3=video',
//                                 image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
//                                 thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
//                             });
//                         }
//                     }
//                 }

//                 // Initialize finalArr with 'NA' for all specified indexes
//                 let maxIndex = Math.max(...videoPlacementIndexes, ...largeImagePlacementIndexes, ...normalPlacementIndexes);
//                 let finalArr = new Array(maxIndex + 1).fill('NA');

//                 // Place videos at specific indexes
//                 videos.forEach((video, index) => {
//                     if (index < videoPlacementIndexes.length) {
//                         finalArr[videoPlacementIndexes[index]] = video;
//                     }
//                 });

//                 // Place large images at specific indexes
//                 largeImages.forEach((image, index) => {
//                     if (index < largeImagePlacementIndexes.length) {
//                         finalArr[largeImagePlacementIndexes[index]] = image;
//                     }
//                 });

//                 // Place other images in the remaining slots
//                 images.forEach((image, index) => {
//                     if (index < normalPlacementIndexes.length) {
//                         finalArr[normalPlacementIndexes[index]] = image;
//                     }
//                 });

//                 // Trim 'NA' from the end if no images or videos exist after the last defined index
//                 while (finalArr.length > 0 && finalArr[finalArr.length - 1] === 'NA') {
//                     finalArr.pop();
//                 }

//                 resolve(finalArr);
//             }
//         });
//     });
// }

async function getMyAllMusaImage(user_id) {
    const sqlSelect = "SELECT mim.musa_image_id, mim.image_audio, mim.thumbnail_image, mim.musa_id, mim.user_id, mim.type, mim.image_audio_type, mim.size_flag,mim.duration FROM musa_image_master as mim , musa_master as mm WHERE mim.user_id = ? and mim.image_audio_type=1 and mim.delete_flag=0 and mim.musa_id=mm.musa_id and mm.delete_flag=0";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                let videos = [];
                let images = [];
               

let normalPlacementIndexes = [0,3, 4, 5,6,7, 10, 11, 12, 13,14,17,18,19,20,21,24,25,26,27,28,31,32,33,34,35,38,39,40,41,42,45,46,47,48,49,52,53,54,55,56,59,60,61,62,63,66,67,68,69,70,73,74,75,76,77,80,81,82,83,84,87,88,89,90,91,94,95,96,97,98,101,102,103,104,105,108,109,110,111,112,115,116,117,118,119,122,123,124,125,126,129,130,131,132,133,136,137,138,139,140,143,144,145,146,147,150,151,152,153,124,157,158,159,160,161,164,165,166,167,168,171,172,173,174,175];

console.log(normalPlacementIndexes);

let videoPlacementIndexes = [1, 2, 8, 9, 15, 16, 22, 23, 29, 30, 36, 37, 43, 44, 50, 51, 57, 58, 64, 65, 71, 72, 78, 79, 85, 86, 92, 93, 99, 100, 106, 107, 113, 114, 120, 121, 127, 128, 134, 135, 141, 142, 148, 149, 155, 156, 162, 163, 169, 170, 176, 177, 183, 184, 190, 191, 197, 198, 204, 205, 211, 212, 218, 219, 225, 226, 232,233,239,240,246,247,253,254,260,261,267,268,274,275,281,282,288,289,295,296,302,303,309,310,316,317,323,324,330,331,337,343,344,350,351,357,358,364,365,371,372,378,379,385,386,392,393,399,400,406,407,413,414,420,421,427,428,434,435,441,442,448,449,455,456,462,463,469,470,476,477,483,484,490,491,497,498,504,505,511,512,518,519,525,526,532,533,539,540,546,547,553,554,560,561,567,568,574,575,581,582,588,589,595,596,602,603,609,610,616,617,623,624,630,631,637,638,644,645,651,652,658,659,665,666,672,673,679,680,686,687,693,694,700,701,707,708,714,715,721,722,728,729,735,736,742,743,749,750,756,757,763,764,770,771,777,778,784,785,791,792,798,799,805,806,812,813,819,820,826,827,833,834,840,841,847,848,856,857,863,864,870,871,877,878,884,885,891,892,898,899,905,906,912,913,919,920,926,927,933,934,940,941,947,948,954,955,961,962,968,969,975,976,982,983,989,990,996,997,1003,1004,1010,1011,1017];

                for (const row of result) {
                    if (row.image_audio_type === 3) { // Video
                        videos.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            size_flag: row.size_flag,
                            size_flag_text: '0=normal,1=lengthy',
                            image_audio_type: row.image_audio_type,
                            image_audio_type_text: '1=image,3=video',
                            image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
                        });
                    }
                        else {
                            images.push({
                                musa_image_id: row.musa_image_id,
                                duration: row.duration,
                                size_flag: row.size_flag,
                                size_flag_text: '0=normal,1=lengthy',
                                image_audio_type: row.image_audio_type,
                                image_audio_type_text: '1=image,3=video',
                                image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                                thumbnail_image: row.thumbnail_image ? 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image : 'NA',
                            });
                    }
                }

                let maxIndex = Math.max(...videoPlacementIndexes,...normalPlacementIndexes);
                let finalArr = new Array(maxIndex + 1).fill('NA');
            
                videos.forEach((video, index) => {
                    if (index < videoPlacementIndexes.length) {
                        finalArr[videoPlacementIndexes[index]] = video;
                    }
                });
            
                // Place other images in the remaining slots
                images.forEach((image, index) => {
                    if (index < normalPlacementIndexes.length) {
                        finalArr[normalPlacementIndexes[index]] = image;
                    }
                });

                // Trim 'NA' from the end if no images or videos exist after the last defined index
                while (finalArr.length > 0 && finalArr[finalArr.length - 1] === 'NA') {
                    finalArr.pop();
                }

                resolve(finalArr);
            }
        });
    });
}
// all my musa images end

// all musa videos start

async function getMyMusavideoNew(user_id) {
    const sqlSelect = "SELECT mim.musa_image_id, mim.image_audio, mim.thumbnail_image, mim.musa_id, mim.user_id, mim.type, mim.image_audio_type, mim.size_flag,mim.duration FROM musa_image_master as mim , musa_master as mm WHERE mim.user_id = ? and mim.image_audio_type = 3 and mim.delete_flag=0 and mim.musa_id=mm.musa_id and mm.delete_flag=0";
    return new Promise((resolve, reject) => {
        connection.query(sqlSelect, [user_id], (err, result) => {
            if (err) {
                reject(err);
            } else {
                let videos = [];
                let images = [];
                let largeImages = [];
             
                for (const row of result) {
                    
                        videos.push({
                            musa_image_id: row.musa_image_id,
                            duration: row.duration,
                            size_flag: row.size_flag,
                            size_flag_text: '0=normal,1=lengthy',
                            image_audio_type: row.image_audio_type,
                            image_audio_type_text: '1=image,3=video',
                            image_audio: 'https://d38i924xuvvpvh.cloudfront.net/images/' + row.image_audio,
                            thumbnail_image: 'https://d38i924xuvvpvh.cloudfront.net/' + row.thumbnail_image,
                        });
                
                }

              

                resolve(videos);
            }
        });
    });
}

// all musa videos end

// chat api start

const UploadChat1 = (request,response) => {
   
    const image = request.body ;
    if (image) {
        return response.status(200).json({ success: true, msg: languageMessages.fileUploadSuccess,image : image});
    } else {
        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, data: '1' });
}
}

// chat api end


async function displayRequestCount1(user_id) {
    const getMusaQuery = "SELECT musa_id FROM musa_master WHERE delete_flag=0 and user_id=?";
    const getCountQueryImage = "SELECT count(request_id) as count FROM display_request_master WHERE delete_flag=0 and musa_id=? and status=0";
   
    
    const query = util.promisify(connection.query).bind(connection);

    try {
        const musaResult = await query(getMusaQuery, [user_id]);
        let musa_count = 0;
     
        for (const data of musaResult) {
            const imageResult = await query(getCountQueryImage, [data.musa_id]);
            musa_count += imageResult[0].count;
        }
        return musa_count;
    } catch (err) {
        throw err;
    }
}

const getAllUsers = async (request,response) =>{

    const { user_id } = request.query;

    try {

        if (!user_id) {
            return response.status(200).json({ success: false, msg: languageMessages.msg_empty_param, key: "user_id" });
        }

        // Check user start
        const sqlCheck = "SELECT user_id, active_flag FROM user_master WHERE user_id = ? AND delete_flag = 0";

        connection.query(sqlCheck, [user_id],async(err, result) => {
            if (err) {
                return response.status(200).json({ success: false, msg: languageMessages.internalServerError, err: err });
            }

            if (result.length <= 0) {
                return response.status(200).json({ success: false, msg: languageMessages.msgDataNotFound });
            }

            if (result[0].active_flag === 0) {
                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated, active_status: 0 });
            }

            const sqlCheck1 = "SELECT user_id,f_name,l_name,image FROM user_master WHERE user_id != ? and user_type != 0 AND delete_flag = 0 and active_flag=1 order by f_name,l_name asc";
            const val1 = [user_id];

            await connection.query(sqlCheck1,val1,async(err1,result1)=>{

                if(err1){
                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError, err1: err1 }); 
                }

                try {

                    var user_arr = [];

                    if(result1.length > 0){

                        user_arr = await Promise.all(
                            result1.map(async(data)=>{
                                return{
                                    user_id : data.user_id,
                                    f_name : data.f_name,
                                    l_name : data.l_name,
                                    image : data.image != null ? 'https://d38i924xuvvpvh.cloudfront.net/'+data.image : 'NA' ,
                                    status : false
                                }
                            })
                        )

                    }else{
                        user_arr = 'NA';
                    }

                    return response.status(200).json({ success: true, msg: languageMessages.msgDataFound, user_arr : user_arr});
                    
                } catch (error) {
                    console.error("Error:", error);
                    return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error : error});
                }

                



            })

        });
        

    } catch (error) {

        console.error("Error:", error);
        return response.status(200).json({ success: false, msg: languageMessages.internalServerError, error : error});

    }
}

module.exports = {purchasePlan,signUp,resendOtp,otpVerify,signIn,deleteAccount,forgetPassword,forgetResedOtpPassword,forgetPassOtpVerify,changePassword,updateNewPassword,contectUs,updateProfile,updateProfileImage, aboutYourSelf,getProfileDetails,getAllPlan,getPlanHistory,getOtherUserProfileDetails,UploadChat1,getAllUsers};





